(module ecore-evas mzscheme
  
  (require (lib "foreign.ss")
           "ecore-common.ss"
           "evas-types.ss")
  (unsafe!)
  (define libecore-evas (ffi-lib "libecore_evas"))
  
  (define-efl-ffi-definer ecore-evas)
  
  (define _EcoreEvasEngineType
    (_enum '(ECORE-EVAS-ENGINE-SOFTWARE-X11
             ECORE-EVAS-ENGINE-SOFTWARE-FB
             ECORE-EVAS-ENGINE-GL-X11
             EVORE-EVAS-ENGINE-SOFTWARE-BUFFER)))
  
  (define _EcoreXWindow _uint)
  
  (define-cpointer-type _EcoreEvas)
  
  (define init-count 0)
  
  ;;Functions
  (defecore-evas* ecore-evas-engine-type-supported-get :
    _EcoreEvasEngineType
    -> _bool)
  
  (defecore-evas* ecore-evas-init :
    (post: (set! init-count o_init-count))
    -> (o_init-count : _sint))
  (defecore-evas* ecore-evas-shutdown :
    (post: (set! init-count o_init-count))
    -> (o_init-count : _sint))
  
  (defecore-evas* ecore-evas-software-x11-new :
    (post: (register-finalizer o_ee ecore-evas-finalize))
    _string  _EcoreXWindow _sint _sint _sint _sint
    -> (o_ee : _EcoreEvas))
  
  (defecore-evas* ecore-evas-software-x11-window-get :
    _EcoreEvas
    -> _EcoreXWindow)
  
  (defecore-evas* ecore-evas-software-x11-subwindow-get :
    _EcoreEvas
    -> _EcoreXWindow)
  
  (defecore-evas* ecore-evas-software-x11-direct-resize-set :
    _EcoreEvas _bool
    -> _void)
  
  (defecore-evas* ecore-evas-software-x11-direct-resize-get :
    _EcoreEvas
    -> _bool)

  (defecore-evas* ecore-evas-gl-x11-new :
    (post: (register-finalizer o_ee ecore-evas-finalize))
    _string _EcoreXWindow _sint _sint _sint _sint
    -> (o_ee : _EcoreEvas))
  
  (defecore-evas* ecore-evas-gl-x11-window-get :
    _EcoreEvas
    -> _EcoreXWindow)
  
  (defecore-evas* ecore-evas-gl-x11-subwindow-get :
    _EcoreEvas
    -> _EcoreXWindow)
  
  (defecore-evas* ecore-evas-gl-x11-direct-resize-set :
    _EcoreEvas _bool
    -> _void)
  
  (defecore-evas* ecore-evas-gl-x11-direct-resize-get :
    _EcoreEvas
    -> _bool)
  
  (defecore-evas* ecore-evas-fb-new :
    (post: (register-finalizer o_ee ecore-evas-finalize))
    _string _sint _sint _sint
    -> (o_ee : _EcoreEvas))
  
  (defecore-evas* ecore-evas-buffer-new :
    (post: (register-finalizer o_ee ecore-evas-finalize))
    _sint _sint
    -> (o_ee : _EcoreEvas))
  
  (defecore-evas* ecore-evas-buffer-pixels-get :
    (i_ee : _EcoreEvas)
    -> (o_pixels : _pointer)
    -> (if o_pixels
           (letrec ((ret (ecore-evas-geometry-get i_ee))
                    (w (caddr ret))
                    (h (cadddr ret))
                    (size (* w h)))
             (cblock->vector o_pixels _sint size))
           #f))
  
  (defecore-evas* ecore-evas-object-image-new : _EcoreEvas -> _EvasObject)
  
  (define (ecore-evas-finalize ee)
    (if (> init-count 0) (ecore-evas-free ee)))
  (defecore-evas ecore-evas-free : _EcoreEvas -> _void)
  
  (defecore-evas* ecore-evas-data-get : _EcoreEvas _string -> _scheme)
  (defecore-evas* ecore-evas-data-set : _EcoreEvas _string _scheme -> _void)
  
  (defecore-evas* ecore-evas-callback-resize-set :
    _EcoreEvas (_fun _EcoreEvas -> _cbvoid)
    -> _void)
  
  (defecore-evas* ecore-evas-callback-move-set :
    _EcoreEvas (_fun _EcoreEvas -> _cbvoid)
    -> _void)
  
  (defecore-evas* ecore-evas-callback-show-set :
    _EcoreEvas (_fun _EcoreEvas -> _cbvoid)
    -> _void)
  
  (defecore-evas* ecore-evas-callback-hide-set :
    _EcoreEvas (_fun _EcoreEvas -> _cbvoid)
    -> _void)
  
  (defecore-evas* ecore-evas-callback-delete-request-set :
    _EcoreEvas (_fun _EcoreEvas -> _cbvoid)
    -> _void)
  
  (defecore-evas* ecore-evas-callback-destroy-set :
    _EcoreEvas (_fun _EcoreEvas -> _cbvoid)
    -> _void)
  
  (defecore-evas* ecore-evas-callback-focus-in-set :
    _EcoreEvas (_fun _EcoreEvas -> _cbvoid)
    -> _void)
  
  (defecore-evas* ecore-evas-callback-focus-out-set :
    _EcoreEvas (_fun _EcoreEvas -> _cbvoid)
    -> _void)
  
  (defecore-evas* ecore-evas-callback-mouse-in-set :
    _EcoreEvas (_fun _EcoreEvas -> _cbvoid)
    -> _void)
  
  (defecore-evas* ecore-evas-callback-mouse-out-set :
    _EcoreEvas (_fun _EcoreEvas -> _cbvoid)
    -> _void)
  
  (defecore-evas* ecore-evas-callback-pre-render-set :
    _EcoreEvas (_fun _EcoreEvas -> _cbvoid)
    -> _void)
  
  (defecore-evas* ecore-evas-callback-post-render-set :
    _EcoreEvas (_fun _EcoreEvas -> _cbvoid)
    -> _void)
  
  (defecore-evas* ecore-evas-get : _EcoreEvas -> _Evas)
  
  (defecore-evas* ecore-evas-move : _EcoreEvas _sint _sint -> _void)
  
  (defecore-evas* ecore-evas-resize : _EcoreEvas _sint _sint -> _void)
  
  (defecore-evas* ecore-evas-move-resize :
    _EcoreEvas _sint _sint _sint _sint
    -> _void)
  
  (defecore-evas* ecore-evas-geometry-get :
    _EcoreEvas
    (o_x : (_ptr o _sint)) (o_y : (_ptr o _sint))
    (o_w : (_ptr o _sint)) (o_h : (_ptr o _sint))
    -> _void
    -> (list o_x o_y o_w o_h))
  
  (defecore-evas* ecore-evas-rotation-set : _EcoreEvas _sint -> _void)
  (defecore-evas* ecore-evas-rotation-get : _EcoreEvas -> _sint)
  
  (defecore-evas* ecore-evas-shaped-set : _EcoreEvas _bool -> _void)
  (defecore-evas* ecore-evas-shaped-get : _EcoreEvas -> _bool)
  
  (defecore-evas* ecore-evas-show : _EcoreEvas -> _void)
  (defecore-evas* ecore-evas-hide : _EcoreEvas -> _void)
  (defecore-evas* ecore-evas-visibility-get : _EcoreEvas -> _bool)
  
  (defecore-evas* ecore-evas-raise : _EcoreEvas -> _void)
  (defecore-evas* ecore-evas-lower : _EcoreEvas -> _void)
  
  (defecore-evas* ecore-evas-title-set : _EcoreEvas _string -> _void)
  (defecore-evas* ecore-evas-title-get : _EcoreEvas -> _string)
  
  (defecore-evas* ecore-evas-name-class-set :
    _EcoreEvas _string _string
    -> _void)
  
  (defecore-evas* ecore-evas-name-class-get :
    _EcoreEvas (o_n : (_ptr o _string)) (o_c : (_ptr o _string))
    -> _void
    -> (list o_n o_c))
  
  (defecore-evas* ecore-evas-size-min-set :
    _EcoreEvas _sint _sint
    -> _void)
  
  (defecore-evas* ecore-evas-size-min-get :
    _EcoreEvas (o_w : (_ptr o _sint)) (o_h : (_ptr o _sint))
    -> _void
    -> (list o_w o_h))
  
  (defecore-evas* ecore-evas-size-max-set :
    _EcoreEvas _sint _sint
    -> _void)
  
  (defecore-evas* ecore-evas-size-max-get :
    _EcoreEvas (o_w : (_ptr o _sint)) (o_h : (_ptr o _sint))
    -> _void
    -> (list o_w o_h))
  
  (defecore-evas* ecore-evas-size-base-set :
    _EcoreEvas _sint _sint
    -> _void)
  
  (defecore-evas* ecore-evas-size-base-get :
    _EcoreEvas (o_w : (_ptr o _sint)) (o_h : (_ptr o _sint))
    -> _void
    -> (list o_w o_h))
  
  (defecore-evas* ecore-evas-size-step-set :
    _EcoreEvas _sint _sint
    -> _void)
  
  (defecore-evas* ecore-evas-size-step-get :
    _EcoreEvas (o_w : (_ptr o _sint)) (o_h : (_ptr o _sint))
    -> _void
    -> (list o_w o_h))
  
  (defecore-evas* ecore-evas-cursor-set :
    _EcoreEvas _file _sint _sint _sint
    -> _void)
  
  (defecore-evas* ecore-evas-cursor-get :
    _EcoreEvas (o_file : (_ptr o _file)) (o_layer : (_ptr o _sint))
    (o_hot-x : (_ptr o _sint)) (o_hot-y : (_ptr o _sint))
    -> _void
    -> (list o_file o_layer o_hot-x o_hot-y))
  
  (defecore-evas* ecore-evas-layer-set : _EcoreEvas _sint -> _void)
  (defecore-evas* ecore-evas-layer-get : _EcoreEvas -> _sint)
  
  (defecore-evas* ecore-evas-focus-set : _EcoreEvas _bool -> _void)
  (defecore-evas* ecore-evas-focus-get : _EcoreEvas -> _bool)
  
  (defecore-evas* ecore-evas-iconified-set : _EcoreEvas _bool -> _void)
  (defecore-evas* ecore-evas-iconified-get : _EcoreEvas -> _bool)
  
  (defecore-evas* ecore-evas-borderless-set : _EcoreEvas _bool -> _void)
  (defecore-evas* ecore-evas-borderless-get : _EcoreEvas -> _bool)
  
  (defecore-evas* ecore-evas-override-set : _EcoreEvas _bool -> _void)
  (defecore-evas* ecore-evas-override-get : _EcoreEvas -> _bool)
  
  (defecore-evas* ecore-evas-maximized-set : _EcoreEvas _bool -> _void)
  (defecore-evas* ecore-evas-maximized-get : _EcoreEvas -> _bool)
  
  (defecore-evas* ecore-evas-fullscreen-set : _EcoreEvas _bool -> _void)
  (defecore-evas* ecore-evas-fullscreen-get : _EcoreEvas -> _bool)
  
  (defecore-evas* ecore-evas-avoid-damage-set : _EcoreEvas _bool -> _void)
  (defecore-evas* ecore-evas-avoid-damage-get : _EcoreEvas -> _bool)
  
  (defecore-evas* ecore-evas-withdrawn-set : _EcoreEvas _bool -> _void)
  (defecore-evas* ecore-evas-withdrawn-get : _EcoreEvas -> _bool)
  
  (defecore-evas* ecore-evas-sticky-set : _EcoreEvas _bool -> _void)
  (defecore-evas* ecore-evas-sticky-get : _EcoreEvas -> _bool))
