(module ecore-x mzscheme
  
  (require (lib "foreign.ss") 
           "ecore-common.ss")
  
  (define libecore-x (ffi-lib "libecore_x"))
  
  (define-efl-exn-raiser ecore-x)
  (define-efl-ffi-definer ecore-x)
  
  (define _EcoreXWMProtocol
    (_enum '(ECORE-X-WM-PROTOCOL-DELETE-REQUEST
             ECORE-X-WM-PROTOCOL-TAKE-FOCUS
	     ECORE-X-NET-WM-PROTOCOL-PING
	     ECORE-X-NET-WM-PROTOCOL-SYNC-REQUEST)))
  
  (define _EcoreXWindowInputMode
    (_enum '(ECORE-X-WINDOW-INPUT-MODE-NONE
             ECORE-X-WINDOW-INPUT-MODE-PASSIVE
             ECORE-X-WINDOW-INPUT-MODE-ACTIVE-LOCAL
             ECORE-X-WINDOW-INPUT-MODE-ACTIVE-GLOBAL)))
  
  (define _EcoreXWindowStateHint
    (_enum '(ECORE-X-WINDOW-STATE-HINT-NONE = -1
             ECORE-X-WINDOW-STATE-HINT-WITHDRAWN
             ECORE-X-WINDOW-STATE-HINT-NORMAL
             ECORE-X-WINDOW-STATE-HINT-ICONIC)))
  
  (define _EcoreXWindowState
    (_enum '(ECORE-X-WINDOW-STATE-ICONIFIED
             ECORE-X-WINDOW-STATE-MODAL
             ECORE-X-WINDOW-STATE-STICKY
             ECORE-X-WINDOW-STATE-MAXIMIZED-VERT
             ECORE-X-WINDOW-STATE-MAXIMIZED-HORZ
             ECORE-X-WINDOW-STATE-SHADED
             ECORE-X-WINDOW-STATE-SKIP-TASKBAR
             ECORE-X-WINDOW-STATE-SKIP-PAGER
             ECORE-X-WINDOW-STATE-HIDDEN
             ECORE-X-WINDOW-STATE-FULLSCREEN
             ECORE-X-WINDOW-STATE-ABOVE
             ECORE-X-WINDOW-STATE-BELOW
             ECORE-X-WINDOW-STATE-DEMANDS-ATTENTION
	     ECORE-X-WINDOW-STATE-UNKNOWN)))

  (define _EcoreXWindowStateAction
    (_enum '(ECORE-X-WINDOW-STATE-ACTION-REMOVE
	     ECORE-X-WINDOW-STATE-ACTION-ADD
	     ECORE-X-WINDOW-STATE-ACTION-TOGGLE)))
  
  (define _EcoreXWindowStackMode
    (_enum '(ECORE-X-WINDOW-STACK-ABOVE = 0
             ECORE-X-WINDOW-STACK-BELOW = 1
             ECORE-X-WINDOW-STACK-TOP-IF = 2
             ECORE-X-WINDOW-STACK-BOTTOM-IF = 3
             ECORE-X-WINDOW-STACK-OPPOSITE = 4)))
  
 
  (define _EcoreXSelection
    (_enum '(ECORE-X-SELECTION-PRIMARY
             ECORE-X-SELECTION-SECONDARY
             ECORE-X-SELECTION-XDND
             ECORE-X-SELECTION-CLIPBOARD)))
  
  (define _EcoreXEventMode
    (_enum '(ECORE-X-EVENT-MODE-NORMAL
             ECORE-X-EVENT-MODE-WHILE-GRABBED
             ECORE-X-EVENT-MODE-GRAB
             ECORE-X-EVENT-MODE-UNGRAB)))
  
  (define _EcoreXEventDetail
    (_enum '(ECORE-X-EVENT-DETAIL-ANCESTOR
             ECORE-X-EVENT-DETAIL-VIRTUAL
             ECORE-X-EVENT-DETAIL-INFERIOR
             ECORE-X-EVENT-DETAIL-NON-LINEAR
             ECORE-X-EVENT-DETAIL-NON-LINEAR-VIRTUAL
             ECORE-X-EVENT-DETAIL-POINTER
             ECORE-X-EVENT-DETAIL-POINTER-ROOT
             ECORE-X-EVENT-DETAIL-DETAIL-NONE)))
  
  (define _EcoreXEventMask
    (_bitmask '(ECORE-X-EVENT-MASK-NONE                   = #o00000000000
                ECORE-X-EVENT-MASK-KEY-DOWN               = #o00000000001
                ECORE-X-EVENT-MASK-KEY-UP                 = #o00000000002
                ECORE-X-EVENT-MASK-MOUSE-DOWN             = #o00000000004
                ECORE-X-EVENT-MASK-MOUSE-UP               = #o00000000010
                ECORE-X-EVENT-MASK-MOUSE-IN               = #o00000000020
                ECORE-X-EVENT-MASK-MOUSE-OUT              = #o00000000040
                ECORE-X-EVENT-MASK-MOUSE-MOVE             = #o00000000100
                ECORE-X-EVENT-MASK-WINDOW-DAMAGE          = #o00000100000
                ECORE-X-EVENT-MASK-WINDOW-VISIBILITY      = #o00000200000
                ECORE-X-EVENT-MASK-WINDOW-CONFIGURE       = #o00000400000
                ECORE-X-EVENT-MASK-WINDOW-RESIZE_MANAGE   = #o00001000000
                ECORE-X-EVENT-MASK-WINDOW-MANAGE          = #o00002000000 
                ECORE-X-EVENT-MASK-WINDOW-CHILD_CONFIGURE = #o00004000000
                ECORE-X-EVENT-MASK-WINDOW-FOCUS_CHANGE    = #o00010000000
                ECORE-X-EVENT-MASK-WINDOW-PROPERTY        = #o00020000000
                ECORE-X-EVENT-MASK-WINDOW-COLORMAP        = #o00040000000
                ECORE-X-EVENT-MASK-WINDOW-GRAB            = #o00100000000
                ECORE-X-EVENT-MASK-MOUSE-WHEEL            = #o04000000000
                ECORE-X-EVENT-MASK-WINDOW-FOCUS-IN        = #o10000000000
                ECORE-X-EVENT-MASK-WINDOW-FOCUS-OUT       = #o20000000000)))
  
  (define _EcoreXGravity
    (_enum '(ECORE-X-GRAVITY-FORGET = 0
             ECORE-X-GRAVITY-UNMAP = 0
             ECORE-X-GRAVITY-NW = 1
             ECORE-X-GRAVITY-N = 2
             ECORE-X-GRAVITY-NE = 3
             ECORE-X-GRAVITY-W = 4
             ECORE-X-GRAVITY-CENTER = 5
             ECORE-X-GRAVITY-E = 6
             ECORE-X-GRAVITY-SW = 7
             ECORE-X-GRAVITY-S = 8
             ECORE-X-GRAVITY-SE = 9
             ECORE-X-GRAVITY-STATIC = 10)))

  (define _EcoreXWindowType
    (_enum '(ECORE-X-WINDOW-TYPE-DESKTOP
             ECORE-X-WINDOW-TYPE-DOCK
             ECORE-X-WINDOW-TYPE-TOOLBAR
             ECORE-X-WINDOW-TYPE-MENU
             ECORE-X-WINDOW-TYPE-UTILITY
             ECORE-X-WINDOW-TYPE-SPLASH
             ECORE-X-WINDOW-TYPE-DIALOG
             ECORE-X-WINDOW-TYPE-NORMAL)))
  
  (define _EcoreXAction
    (_enum '(ECORE-X-ACTION-MOVE
             ECORE-X-ACTION-RESIZE
             ECORE-X-ACTION-MINIMIZE
             ECORE-X-ACTION-SHADE
             ECORE-X-ACTION-STICK
             ECORE_X-ACTION-MAXIMIZE-HORZ
             ECORE-X-ACTION-MAXIMIZE-VERT
             ECORE-X-ACTION-FULLSCREEN
             ECORE-X-ACTION-CHANGE-DESKTOP
             ECORE-X-ACTION-CLOSE)))
  
  (define _EcoreXWindowConfigureMask
    (_bitmask '(ECORE-X-WINDOW-CONFIGURE-MASK-X              = #o001
                ECORE-X-WINDOW-CONFIGURE-MASK-Y              = #o002
                ECORE-X-WINDOW-CONFIGURE-MASK-W              = #o004
                ECORE-X-WINDOW-CONFIGURE-MASK-H              = #o010
                ECORE-X-WINDOW-CONFIGURE-MASK-BORDER-WIDTH   = #o020
                ECORE-X-WINDOW-CONFIGURE-MASK-SIBLING        = #o040
                ECORE-X-WINDOW-CONFIGURE-MASK-STACK-MODE     = #o100)))
  
 (define _EcoreXWindowLayer
    '(_enum (ECORE-X-WINDOW-LAYER-BELOW = 2
             ECORE-X-WINDOW-LAYER-NORMAL = 4
             ECORE-X-WINDOW-LAYER-ABOVE = 6)))
  
  (define _EcoreXMWMHintFunc
    (_bitmask '(ECORE-X-MWM-HINT-FUNC-ALL      = #o01
                ECORE-X-MWM-HINT-FUNC-RESIZE   = #o02
                ECORE-X-MWM-HINT-FUNC-MOVE     = #o04
                ECORE-X-MWM-HINT-FUNC-MINIMIZE = #o10
                ECORE-X-MWM-HINT-FUNC-MAXIMIZE = #o20
                ECORE-X-MWM-HINT-FUNC-CLOSE    = #o40)))

  (define _EcoreXMWMHintDecor
    (_bitmask '(ECORE-X-MWM-HINT-DECOR-ALL      = #o001
                ECORE-X-MWM-HINT-DECOR-BORDER   = #o002
                ECORE-X-MWM-HINT-DECOR-RESIZEH  = #o004
                ECORE-X-MWM-HINT-DECOR-TITLE    = #o010
                ECORE-X-MWM-HINT-DECOR-MENU     = #o020
                ECORE-X-MWM-HINT-DECOR-MINIMIZE = #o040
                ECORE-X-MWM-HINT-DECOR-MAXIMIZE = #o100)))
  
  (define _EcoreXMWMHintInput
    (_enum '(ECORE-X-MWM-INPUT-MODELESS = 0
             ECORE-X-MWM-INPUT-PRIMARY-APPLICATION-MODAL = 1
             ECORE-X-MWM-INPUT-SYSTEM-MODAL = 2
             ECORE-X-MWM-INPUT-FULL-APPLICATION-MODAL = 3)))
  
  (define _EcoreXCursorType
    (_enum '(ECORE-X-CURSOR-X = 0
             ECORE-X-CURSOR-ARROW = 2
             ECORE-X-CURSOR-BASED-ARROW-DOWN = 4
             ECORE-X-CURSOR-UP = 6
             ECORE-X-CURSOR-BOAT = 8
             ECORE-X-CURSOR-BOTTOM-LEFT-CORNER = 12
             ECORE-X-CURSOR-BOTTOM-RIGHT-CORNER = 14
             ECORE-X-CURSOR-BOTTOM-SIDE = 16
             ECORE-X-CURSOR-BOTTOM-TEE = 18
             ECORE-X-CURSOR-BOX-SPIRAL = 20
             ECORE-X-CURSOR-CENTER-PTR = 22
             ECORE-X-CURSOR-CIRCLE = 24
             ECORE-X-CURSOR-CLOCK = 26
             ECORE-X-CURSOR-COFFEE-MUG = 28
             ECORE-X-CURSOR-CROSS = 30
             ECORE-X-CURSOR-CROSS-REVERSE = 32
             ECORE-X-CURSOR-CROSSHAIR = 34
             ECORE-X-CURSOR-DIAMOND-CROSS = 36
             ECORE-X-CURSOR-DOT = 38
             ECORE-X-CURSOR-DOT-BOX-MASK = 40
             ECORE-X-CURSOR-DOUBLE-ARROW = 42
             ECORE-X-CURSOR-DRAFT-LARGE = 44
             ECORE-X-CURSOR-DRAFT-SMALL = 46
             ECORE-X-CURSOR-DRAPED-BOX = 48
             ECORE-X-CURSOR-EXCHANGE = 50
             ECORE-X-CURSOR-FLEUR = 52
             ECORE-X-CURSOR-GOBBLER = 54
             ECORE-X-CURSOR-GUMBY = 56
             ECORE-X-CURSOR-HAND1 = 58
             ECORE-X-CURSOR-HAND2 = 60
             ECORE-X-CURSOR-HEART = 62
             ECORE-X-CURSOR-ICON = 64
             ECORE-X-CURSOR-IRON-CROSS = 66
             ECORE-X-CURSOR-LEFT-PTR = 68
             ECORE-X-CURSOR-LEFT-SIDE = 70
             ECORE-X-CURSOR-LEFT-TEE = 72
             ECORE-X-CURSOR-LEFTBUTTON = 74
             ECORE-X-CURSOR-LL-ANGLE = 76
             ECORE-X-CURSOR-LR-ANGLE = 78
             ECORE-X-CURSOR-MAN = 80
             ECORE-X-CURSOR-MIDDLEBUTTON = 82
             ECORE-X-CURSOR-MOUSE = 84
             ECORE-X-CURSOR-PENCIL = 86
             ECORE-X-CURSOR-PIRATE = 88
             ECORE-X-CURSOR-PLUS = 90
             ECORE-X-CURSOR-QUESTION-ARROW = 92
             ECORE-X-CURSOR-RIGHT-PTR = 94
             ECORE-X-CURSOR-RIGHT-SIDE = 96
             ECORE-X-CURSOR-RIGHT-TEE = 98
             ECORE-X-CURSOR-RIGHTBUTTON = 100
             ECORE-X-CURSOR-RTL-LOGO = 102
             ECORE-X-CURSOR-SAILBOAT = 104
             ECORE-X-CURSOR-SB-DOWN-ARROW = 106
             ECORE-X-CURSOR-SB-H-DOUBLE-ARROW = 108
             ECORE-X-CURSOR-SB-LEFT-ARROW = 110
             ECORE-X-CURSOR-SB-RIGHT-ARROW = 112
             ECORE-X-CURSOR-SB-UP-ARROW = 114
             ECORE-X-CURSOR-SB-V-DOUBLE-ARROW = 116
             ECORE-X-CURSOR-SHUTTLE = 118
             ECORE-X-CURSOR-SIZING = 120
             ECORE-X-CURSOR-SPIDER = 122
             ECORE-X-CURSOR-SPRAYCAN = 124
             ECORE-X-CURSOR-STAR = 126
             ECORE-X-CURSOR-TARGET = 128
             ECORE-X-CURSOR-TCROSS = 130
             ECORE-X-CURSOR-TOP-LEFT-ARROW = 132
             ECORE-X-CURSOR-TOP-LEFT-CORNER = 134
             ECORE-X-CURSOR-TOP-RIGHT-CORNER = 136
             ECORE-X-CURSOR-TOP-SIDE = 138
             ECORE-X-CURSOR-TOP-TEE = 140
             ECORE-X-CURSOR-TREK = 142
             ECORE-X-CURSOR-UL-ANGLE = 144
             ECORE-X-CURSOR-UMBRELLA = 146
             ECORE-X-CURSOR-UR-ANGLE = 148
             ECORE-X-CURSOR-WATCH = 150
             ECORE-X-CURSOR-XTERM = 152)))

#| defines, hacer un tipo??
    ECORE-X-SELECTION-TARGET-TARGETS "TARGETS"
    ECORE-X-SELECTION-TARGET-TEXT "TEXT"
    ECORE-X-SELECTION-TARGET-COMPOUND-TEXT "COMPOUND_TEXT"
    ECORE-X-SELECTION-TARGET-STRING "STRING"
    ECORE-X-SELECTION-TARGET-UTF8-STRING "UTF8_STRING"
    ECORE-X-SELECTION-TARGET-FILENAME "FILENAME"

    ECORE-X-DND-VERSION 5
|#

  (define _EcoreXID _uint)
  (define _EcoreXWindow _EcoreXID)
  (define _EcoreXPixmap _EcoreXID)
  (define _EcoreXDrawable _EcoreXID)
  (define-cpointer-type _EcoreXGC _pointer)
  (define _EcoreXAtom _EcoreXID)
  (define _EcoreXColormap _EcoreXID)
  (define _EcoreXTime _EcoreXID)
  (define _EcoreXCursor _EcoreXID)
  (define-cpointer-type _EcoreXDisplay _pointer)
  
  (define-cstruct* _EcoreXRectangle
    ((x _sint) (y _sint) (width _uint) (height _uint)))
  (define-cstruct* _EcoreXEventKeyDown
    ((keyname _string) (keysymbol _string) (keycompose _string)
     (modifiers _sint) (win _EcoreXWindow) (event-win _EcoreXWindow)
     (time _EcoreXTime)))
  (define-cstruct* _EcoreXEventKeyUp
    ((keyname _string) (keysymbol _string) (keycompose _string)
     (modifiers _sint) (win _EcoreXWindow) (event-win _EcoreXWindow)
     (time _EcoreXTime)))
  (define-cstruct* _EcoreXEventMouseButtonDown
    ((button _sint) (modifiers _sint) (x _sint) (y _sint)
     (root-x _sint) (root-y _sint) (win _EcoreXWindow)
     (event-win _EcoreXWindow) (time _EcoreXTime)
     (double-click/triple-click _sint)))
  (define-cstruct* _EcoreXEventMouseButtonUp
    ((button _sint) (modifiers _sint) (x _sint) (y _sint)
     (root-x _sint) (root-y _sint) (win _EcoreXWindow)
     (event-win _EcoreXWindow) (time _EcoreXTime)))
  (define-cstruct* _EcoreXEventMouseMove
    ((modifiers _sint) (x _sint) (y _sint)
     (root-x _sint) (root-y _sint) (win _EcoreXWindow)
     (event-win _EcoreXWindow) (time _EcoreXTime)))
  (define-cstruct* _EcoreXEventMouseIn
    ((modifiers _sint) (x _sint) (y _sint)
     (root-x _sint) (root-y _sint) (win _EcoreXWindow)
     (event-win _EcoreXWindow) (mode _EcoreXEventMode)
     (detail _EcoreXEventDetail) (time _EcoreXTime)))
  (define-cstruct* _EcoreXEventMouseOut
    ((modifiers _sint) (x _sint) (y _sint)
     (root-x _sint) (root-y _sint) (win _EcoreXWindow)
     (event-win _EcoreXWindow) (mode _EcoreXEventMode)
     (detail _EcoreXEventDetail) (time _EcoreXTime)))
  (define-cstruct* _EcoreXEventMouseWheel
    ((direction _sint) (z _sint) (modifiers _sint) (x _sint) (y _sint)
     (root-x _sint) (root-y _sint) (win _EcoreXWindow)
     (event-win _EcoreXWindow) (time _EcoreXTime)))
  (define-cstruct* _EcoreXEventWindowFocusIn
    ((win _EcoreXWindow) (mode _EcoreXEventMode)
     (detail _EcoreXEventDetail) (time _EcoreXTime)))
  (define-cstruct* _EcoreXEventWindowFocusOut
    ((win _EcoreXWindow) (mode _EcoreXEventMode)
     (detail _EcoreXEventDetail) (time _EcoreXTime)))
  (define-cstruct* _EcoreXEventWindowKeymap
    ((win _EcoreXWindow)))
  (define-cstruct* _EcoreXEventWindowDamage
    ((win _EcoreXWindow) (x _sint) (y _sint) (w _sint) (h _sint)
     (time _EcoreXTime)))
  (define-cstruct* _EcoreXEventWindowVisibilityChange
    ((win _EcoreXWindow) (fully_obscured _sint) (time _EcoreXTime)))
  (define-cstruct* _EcoreXEventWindowCreate
    ((win _EcoreXWindow) (override _sint)
     (time _EcoreXTime)))
  (define-cstruct* _EcoreXEventWindowDestroy
    ((win _EcoreXWindow) (time _EcoreXTime)))
  (define-cstruct* _EcoreXEventWindowHide
    ((win _EcoreXWindow) (time _EcoreXTime)))
  (define-cstruct* _EcoreXEventWindowShow
    ((win _EcoreXWindow) (time _EcoreXTime)))
  (define-cstruct* _EcoreXEventWindowShowRequest
    ((win _EcoreXWindow) (parent _EcoreXWindow) (time _EcoreXTime)))
  (define-cstruct* _EcoreXEventWindowReparent
    ((win _EcoreXWindow) (parent _EcoreXWindow) (time _EcoreXTime)))
  (define-cstruct* _EcoreXEventWindowConfigure
    ((win _EcoreXWindow) (abovewin _EcoreXWindow) (x _sint) (y _sint)
     (w _sint) (h _sint) (override/from-wm _sint) (time _EcoreXTime)))
  (define-cstruct* _EcoreXEventWindowConfigureRequest
    ((win _EcoreXWindow) (abovewin _EcoreXWindow) (x _sint) (y _sint)
     (w _sint) (h _sint)  (border _sint) (detail _EcoreXWindowStackMode)
     (value-mask _ulong) (time _EcoreXTime)))
  (define-cstruct* _EcoreXEventWindowGravity
    ((win _EcoreXWindow) (time _EcoreXTime)))
  (define-cstruct* _EcoreXEventWindowResizeRequest
    ((win _EcoreXWindow) (w _sint) (h _sint) (time _EcoreXTime)))
  (define-cstruct* _EcoreXEventWindowStack
    ((win _EcoreXWindow) (time _EcoreXTime)))
  (define-cstruct* _EcoreXEventWindowStackRequest
    ((win _EcoreXWindow) (time _EcoreXTime)))
  (define-cstruct* _EcoreXEventWindowProperty
    ((win _EcoreXWindow) (atom _EcoreXAtom) (time _EcoreXTime)))
  (define-cstruct* _EcoreXEventWindowColormap
    ((win _EcoreXWindow) (cmap _EcoreXColormap) (installed _sint)
     (time _EcoreXTime)))
  (define-cstruct* _EcoreXEventSelectionClear
    ((win _EcoreXWindow) (selection _EcoreXSelection) (time _EcoreXTime)))
  (define-cstruct* _EcoreXEventSelectionRequest
    ((win _EcoreXWindow) (time _EcoreXTime)))
  (define-cstruct* _EcoreXEventSelectionNotify
    ((win _EcoreXWindow) (time _EcoreXTime) (selection _EcoreXSelection)
     (target _string) (data _pointer)
     (content (_enum '(ECORE-X-SELECTION-CONTENT-NONE
                       ECORE-X-SELECTION-CONTENT-TEXT
                       ECORE-X-SELECTION-CONTENT-FILES
                       ECORE-X-SELECTION-CONTENT-TARGETS
                       ECORE-X-SELECTION-CONTENT-CUSTOM)))))
  (define-cstruct* _EcoreXSelectionData
    ((data _pointer) (lenght _sint) (free (_fun _pointer -> _sint)))) ;X
  (define-cstruct* _EcoreXSelectionDataFiles
    ((data _EcoreXSelectionData) (files _pointer) (num-files _sint)))
  (define-cstruct* _EcoreXSelectionDataText
    ((data _EcoreXSelectionData) (text _string)))
  (define-cstruct* _EcoreXSelectionDataTargets
    ((data _EcoreXSelectionData) (types _pointer) (num-types _sint)))
  (define-cstruct* _EcoreXEventXdndEnter
    ((win _EcoreXWindow) (source _EcoreXWindow)
     (types _pointer) (num-types _sint)))
  (define-cstruct* _EcoreXEventXdndPosition
    ((win _EcoreXWindow) (source _EcoreXWindow)
     (position-x _sint) (position-y _sint) (action _EcoreXAtom)))
  (define-cstruct* _EcoreXEventXdndStatus
    ((win _EcoreXWindow) (target _EcoreXWindow) (will-accept _sint)
     (rectangle _EcoreXRectangle) (action _EcoreXAtom)))
  (define-cstruct* _EcoreXEventXdndLeave
    ((win _EcoreXWindow) (source _EcoreXWindow)))
  (define-cstruct* _EcoreEventXdndDrop
    ((win _EcoreXWindow) (source _EcoreXWindow) (action _EcoreXAtom)
     (position-x _sint) (position-y _sint)))
  (define-cstruct* _EcoreXEventXdndFinished
    ((win _EcoreXWindow) (target _EcoreXWindow)
     (completed _sint) (action _EcoreXAtom)))
  (define-cstruct* _EcoreXEventWindowState
    ((win _EcoreXWindow) (action _EcoreXWindowStateAction)
     (state0 _EcoreXWindowState) (state1 _EcoreXWindowState)
     (source _sint))) ;FIX:state[2]
;  (define-cstruct* _EcoreXEventClientMessage
;    ((win _EcoreXWindow) (message-type _EcoreXAtom) (format _sint)
;     (l (_cvector _slong 5)) (time _EcoreXTime))) ;FIX
  (define-cstruct* _EcoreXEventWindowShape
    ((win _EcoreXWindow) (time _EcoreXTime)))
  (define-cstruct* _EcoreXEventWindowDeleteRequest
    ((win _EcoreXWindow) (time _EcoreXTime)))
  (define-cstruct* _EcoreXEventWindowPropTitleChange
    ((win _EcoreXWindow) (title _string) (time _EcoreXTime)))
  (define-cstruct* _EcoreXEventWindowPropVisibleTitleChange
    ((win _EcoreXWindow) (title _string) (time _EcoreXTime)))
  (define-cstruct* _EcoreXEventWindowPropIconNameChange
    ((win _EcoreXWindow) (name _string) (time _EcoreXTime)))
  (define-cstruct* _EcoreXEventWindowPropVisibleIconNameChange
    ((win _EcoreXWindow) (name _string) (time _EcoreXTime)))
  (define-cstruct* _EcoreXEventWindowPropClientMachineChange
    ((win _EcoreXWindow) (name _string) (time _EcoreXTime)))
  (define-cstruct* _EcoreXEventWindowPropNameClassChange
    ((win _EcoreXWindow) (name _string) (clas _string) (time _EcoreXTime)))
  (define-cstruct* _EcoreXEventWindowPropPidChange
    ((win _EcoreXWindow) (pid _pid-t) (time _EcoreXTime)))
  (define-cstruct* _EcoreXEventWindowPropDesktopChange
    ((win _EcoreXWindow) (desktop _slong) (time _EcoreXTime)))
  
  ;; General 
  (def-extern ECORE-X-ATOM-UTF8-STRING libecore-x _EcoreXAtom)
  (def-extern ECORE-X-ATOM-FILE-NAME libecore-x _EcoreXAtom)
  (def-extern ECORE-X-ATOM-STRING libecore-x _EcoreXAtom)
  (def-extern ECORE-X-ATOM-TEXT libecore-x _EcoreXAtom)
  (def-extern ECORE-X-ATOM-COMPOUND-TEXT libecore-x _EcoreXAtom)
  
  ;; ICCCM 
  (def-extern ECORE-X-ATOM-WM-STATE libecore-x _EcoreXAtom)
  (def-extern ECORE-X-ATOM-WM-DELETE-WINDOW libecore-x _EcoreXAtom)
  (def-extern ECORE-X-ATOM-WM-TAKE-FOCUS libecore-x _EcoreXAtom)
  (def-extern ECORE-X-ATOM-WM-PROTOCOLS libecore-x _EcoreXAtom)
  (def-extern ECORE-X-ATOM-WM-CLASS libecore-x _EcoreXAtom)
  (def-extern ECORE-X-ATOM-WM-NAME libecore-x _EcoreXAtom)
  (def-extern ECORE-X-ATOM-WM-COMMAND libecore-x _EcoreXAtom)
  (def-extern ECORE-X-ATOM-WM-ICON-NAME libecore-x _EcoreXAtom)
  (def-extern ECORE-X-ATOM-WM-CLIENT-MACHINE libecore-x _EcoreXAtom)
  (def-extern ECORE-X-ATOM-WM-CHANGE-STATE libecore-x _EcoreXAtom)
  (def-extern ECORE-X-ATOM-WM-COLORMAP-WINDOWS libecore-x _EcoreXAtom)
  (def-extern ECORE-X-ATOM-WM-WINDOW-ROLE libecore-x _EcoreXAtom)
  (def-extern ECORE-X-ATOM-WM-HINTS libecore-x _EcoreXAtom)
  (def-extern ECORE-X-ATOM-WM-NORMAL-HINTS libecore-x _EcoreXAtom)
  (def-extern ECORE-X-ATOM-WM-CLIENT-LEADER libecore-x _EcoreXAtom)
  (def-extern ECORE-X-ATOM-WM-TRANSIENT-FOR libecore-x _EcoreXAtom)
  (def-extern ECORE-X-ATOM-WM-SAVE-YOURSELF libecore-x _EcoreXAtom)
  
  ;; MWM 
  (def-extern ECORE-X-ATOM-MOTIF-WM-HINTS libecore-x _EcoreXAtom)
  
  ;; GNOME 
  (def-extern ECORE-X-ATOM-WIN-LAYER libecore-x _EcoreXAtom)
  
  ;; EWMH 
  (def-extern ECORE-X-ATOM-NET-NUMBER-OF-DESKTOPS libecore-x _EcoreXAtom)
  (def-extern ECORE-X-ATOM-NET-VIRTUAL-ROOTS libecore-x _EcoreXAtom)
  (def-extern ECORE-X-ATOM-NET-DESKTOP-NAMES libecore-x _EcoreXAtom)
  (def-extern ECORE-X-ATOM-NET-DESKTOP-GEOMETRY libecore-x _EcoreXAtom)
  (def-extern ECORE-X-ATOM-NET-DESKTOP-VIEWPORT libecore-x _EcoreXAtom)
  (def-extern ECORE-X-ATOM-NET-DESKTOP-LAYOUT libecore-x _EcoreXAtom)
  (def-extern ECORE-X-ATOM-NET-WORKAREA libecore-x _EcoreXAtom)
  
  (def-extern ECORE-X-ATOM-NET-CURRENT-DESKTOP libecore-x _EcoreXAtom)
  (def-extern ECORE-X-ATOM-NET-SHOWING-DESKTOP libecore-x _EcoreXAtom)
  
  (def-extern ECORE-X-ATOM-NET-CLIENT-LIST libecore-x _EcoreXAtom)
  (def-extern ECORE-X-ATOM-NET-CLIENT-LIST-STACKING libecore-x _EcoreXAtom)
  (def-extern ECORE-X-ATOM-NET-ACTIVE-WINDOW libecore-x _EcoreXAtom)
  
  (def-extern ECORE-X-ATOM-NET-WM-NAME libecore-x _EcoreXAtom)
  (def-extern ECORE-X-ATOM-NET-WM-VISIBLE-NAME libecore-x _EcoreXAtom)
  (def-extern ECORE-X-ATOM-NET-WM-ICON-NAME libecore-x _EcoreXAtom)
  (def-extern ECORE-X-ATOM-NET-WM-VISIBLE-ICON-NAME libecore-x _EcoreXAtom)
  (def-extern ECORE-X-ATOM-NET-WM-DESKTOP libecore-x _EcoreXAtom)
  (def-extern ECORE-X-ATOM-NET-WM-STRUT libecore-x _EcoreXAtom)
  (def-extern ECORE-X-ATOM-NET-WM-STRUT-PARTIAL libecore-x _EcoreXAtom)
  (def-extern ECORE-X-ATOM-NET-WM-ICON-GEOMETRY libecore-x _EcoreXAtom)
  (def-extern ECORE-X-ATOM-NET-WM-ICON libecore-x _EcoreXAtom)
  (def-extern ECORE-X-ATOM-NET-WM-PID libecore-x _EcoreXAtom)
  (def-extern ECORE-X-ATOM-NET-WM-HANDLED-ICONS libecore-x _EcoreXAtom)
  (def-extern ECORE-X-ATOM-NET-WM-USER-TIME libecore-x _EcoreXAtom)
  
  (def-extern ECORE-X-ATOM-NET-WM-ALLOWED-ACTIONS libecore-x _EcoreXAtom)
  (def-extern ECORE-X-ATOM-NET-WM-ACTION-MOVE libecore-x _EcoreXAtom)
  (def-extern ECORE-X-ATOM-NET-WM-ACTION-RESIZE libecore-x _EcoreXAtom)
  (def-extern ECORE-X-ATOM-NET-WM-ACTION-MINIMIZE libecore-x _EcoreXAtom)
  (def-extern ECORE-X-ATOM-NET-WM-ACTION-SHADE libecore-x _EcoreXAtom)
  (def-extern ECORE-X-ATOM-NET-WM-ACTION-STICK libecore-x _EcoreXAtom)
  (def-extern ECORE-X-ATOM-NET-WM-ACTION-MAXIMIZE-HORZ libecore-x _EcoreXAtom)
  (def-extern ECORE-X-ATOM-NET-WM-ACTION-MAXIMIZE-VERT libecore-x _EcoreXAtom)
  (def-extern ECORE-X-ATOM-NET-WM-ACTION-FULLSCREEN libecore-x _EcoreXAtom)
  (def-extern ECORE-X-ATOM-NET-WM-ACTION-CHANGE-DESKTOP libecore-x _EcoreXAtom)
  (def-extern ECORE-X-ATOM-NET-WM-ACTION-CLOSE libecore-x _EcoreXAtom)
  
  (def-extern ECORE-X-ATOM-NET-WM-WINDOW-TYPE libecore-x _EcoreXAtom)
  (def-extern ECORE-X-ATOM-NET-WM-WINDOW-TYPE-DESKTOP libecore-x _EcoreXAtom)
  (def-extern ECORE-X-ATOM-NET-WM-WINDOW-TYPE-DOCK libecore-x _EcoreXAtom)
  (def-extern ECORE-X-ATOM-NET-WM-WINDOW-TYPE-TOOLBAR libecore-x _EcoreXAtom)
  (def-extern ECORE-X-ATOM-NET-WM-WINDOW-TYPE-MENU libecore-x _EcoreXAtom)
  (def-extern ECORE-X-ATOM-NET-WM-WINDOW-TYPE-UTILITY libecore-x _EcoreXAtom)
  (def-extern ECORE-X-ATOM-NET-WM-WINDOW-TYPE-SPLASH libecore-x _EcoreXAtom)
  (def-extern ECORE-X-ATOM-NET-WM-WINDOW-TYPE-DIALOG libecore-x _EcoreXAtom)
  (def-extern ECORE-X-ATOM-NET-WM-WINDOW-TYPE-NORMAL libecore-x _EcoreXAtom)
  
  (def-extern ECORE-X-ATOM-NET-WM-STATE libecore-x _EcoreXAtom)
  (def-extern ECORE-X-ATOM-NET-WM-STATE-MODAL libecore-x _EcoreXAtom)
  (def-extern ECORE-X-ATOM-NET-WM-STATE-STICKY libecore-x _EcoreXAtom)
  (def-extern ECORE-X-ATOM-NET-WM-STATE-MAXIMIZED-VERT libecore-x _EcoreXAtom)
  (def-extern ECORE-X-ATOM-NET-WM-STATE-MAXIMIZED-HORZ libecore-x _EcoreXAtom)
  (def-extern ECORE-X-ATOM-NET-WM-STATE-SHADED libecore-x _EcoreXAtom)
  (def-extern ECORE-X-ATOM-NET-WM-STATE-SKIP-TASKBAR libecore-x _EcoreXAtom)
  (def-extern ECORE-X-ATOM-NET-WM-STATE-SKIP-PAGER libecore-x _EcoreXAtom)
  (def-extern ECORE-X-ATOM-NET-WM-STATE-HIDDEN libecore-x _EcoreXAtom)
  (def-extern ECORE-X-ATOM-NET-WM-STATE-FULLSCREEN libecore-x _EcoreXAtom)
  (def-extern ECORE-X-ATOM-NET-WM-STATE-ABOVE libecore-x _EcoreXAtom)
  (def-extern ECORE-X-ATOM-NET-WM-STATE-BELOW libecore-x _EcoreXAtom)
  (def-extern ECORE-X-ATOM-NET-WM-STATE-DEMANDS-ATTENTION libecore-x _EcoreXAtom)
  
  (def-extern ECORE-X-ATOM-NET-WM-WINDOW-OPACITY libecore-x _EcoreXAtom)
  
  (def-extern ECORE-X-ATOM-NET-FRAME-EXTENTS libecore-x _EcoreXAtom)
  (def-extern ECORE-X-ATOM-NET-REQUEST-FRAME-EXTENTS libecore-x _EcoreXAtom)
  
  ;; Selections 
  (def-extern ECORE-X-ATOM-SELECTION-TARGETS libecore-x _EcoreXAtom)
  (def-extern ECORE-X-ATOM-SELECTION-PRIMARY libecore-x _EcoreXAtom)
  (def-extern ECORE-X-ATOM-SELECTION-SECONDARY libecore-x _EcoreXAtom)
  (def-extern ECORE-X-ATOM-SELECTION-CLIPBOARD libecore-x _EcoreXAtom)
  (def-extern ECORE-X-ATOM-SELECTION-PROP-PRIMARY libecore-x _EcoreXAtom)
  (def-extern ECORE-X-ATOM-SELECTION-PROP-SECONDARY libecore-x _EcoreXAtom)
  (def-extern ECORE-X-ATOM-SELECTION-PROP-CLIPBOARD libecore-x _EcoreXAtom)
  
  ;; DND 
  (def-extern ECORE-X-ATOM-SELECTION-XDND libecore-x _EcoreXAtom)
  (def-extern ECORE-X-ATOM-SELECTION-PROP-XDND libecore-x _EcoreXAtom)
  (def-extern ECORE-X-ATOM-XDND-AWARE libecore-x _EcoreXAtom)
  (def-extern ECORE-X-ATOM-XDND-TYPE-LIST libecore-x _EcoreXAtom)
  (def-extern ECORE-X-ATOM-XDND-ACTION-COPY libecore-x _EcoreXAtom)
  (def-extern ECORE-X-ATOM-XDND-ACTION-PRIVATE libecore-x _EcoreXAtom)
  (def-extern ECORE-X-ATOM-XDND-ACTION-ASK libecore-x _EcoreXAtom)
  (def-extern ECORE-X-ATOM-XDND-ACTION-LIST libecore-x _EcoreXAtom)
  (def-extern ECORE-X-ATOM-XDND-ACTION-DESCRIPTION libecore-x _EcoreXAtom)
  (def-extern ECORE-X-ATOM-XDND-ENTER libecore-x _EcoreXAtom)
  (def-extern ECORE-X-ATOM-XDND-LEAVE libecore-x _EcoreXAtom)
  (def-extern ECORE-X-ATOM-XDND-STATUS libecore-x _EcoreXAtom)
  (def-extern ECORE-X-ATOM-XDND-POSITION libecore-x _EcoreXAtom)
  (def-extern ECORE-X-ATOM-XDND-DROP libecore-x _EcoreXAtom)
  (def-extern ECORE-X-ATOM-XDND-FINISHED libecore-x _EcoreXAtom)

  (def-extern ECORE-X-DND-ACTION-COPY libecore-x _EcoreXAtom)
  (def-extern ECORE-X-DND-ACTION-MOVE libecore-x _EcoreXAtom)
  (def-extern ECORE-X-DND-ACTION-LINK libecore-x _EcoreXAtom)
  (def-extern ECORE-X-DND-ACTION-ASK libecore-x _EcoreXAtom)
  (def-extern ECORE-X-DND-ACTION-PRIVATE libecore-x _EcoreXAtom)
  
  ;; Other variables
  (def-extern ECORE-X-EVENT-KEY-DOWN libecore-x _sint)
  (def-extern ECORE-X-EVENT-KEY-UP libecore-x _sint)
  (def-extern ECORE-X-EVENT-MOUSE-BUTTON-DOWN libecore-x _sint)
  (def-extern ECORE-X-EVENT-MOUSE-BUTTON-UP libecore-x _sint)
  (def-extern ECORE-X-EVENT-MOUSE-MOVE libecore-x _sint)
  (def-extern ECORE-X-EVENT-MOUSE-IN libecore-x _sint)
  (def-extern ECORE-X-EVENT-MOUSE-OUT libecore-x _sint)
  (def-extern ECORE-X-EVENT-MOUSE-WHEEL libecore-x _sint)
  (def-extern ECORE-X-EVENT-WINDOW-FOCUS-IN libecore-x _sint)
  (def-extern ECORE-X-EVENT-WINDOW-FOCUS-OUT libecore-x _sint)
  (def-extern ECORE-X-EVENT-WINDOW-KEYMAP libecore-x _sint)
  (def-extern ECORE-X-EVENT-WINDOW-DAMAGE libecore-x _sint)
  (def-extern ECORE-X-EVENT-WINDOW-VISIBILITY-CHANGE libecore-x _sint)
  (def-extern ECORE-X-EVENT-WINDOW-CREATE libecore-x _sint)
  (def-extern ECORE-X-EVENT-WINDOW-DESTROY libecore-x _sint)
  (def-extern ECORE-X-EVENT-WINDOW-HIDE libecore-x _sint)
  (def-extern ECORE-X-EVENT-WINDOW-SHOW libecore-x _sint)
  (def-extern ECORE-X-EVENT-WINDOW-SHOW-REQUEST libecore-x _sint)
  (def-extern ECORE-X-EVENT-WINDOW-REPARENT libecore-x _sint)
  (def-extern ECORE-X-EVENT-WINDOW-CONFIGURE libecore-x _sint)
  (def-extern ECORE-X-EVENT-WINDOW-CONFIGURE-REQUEST libecore-x _sint)
  (def-extern ECORE-X-EVENT-WINDOW-GRAVITY libecore-x _sint)
  (def-extern ECORE-X-EVENT-WINDOW-RESIZE-REQUEST libecore-x _sint)
  (def-extern ECORE-X-EVENT-WINDOW-STACK libecore-x _sint)
  (def-extern ECORE-X-EVENT-WINDOW-STACK-REQUEST libecore-x _sint)
  (def-extern ECORE-X-EVENT-WINDOW-PROPERTY libecore-x _sint)
  (def-extern ECORE-X-EVENT-WINDOW-COLORMAP libecore-x _sint)
  (def-extern ECORE-X-EVENT-WINDOW-MAPPING libecore-x _sint)
  (def-extern ECORE-X-EVENT-SELECTION-CLEAR libecore-x _sint)
  (def-extern ECORE-X-EVENT-SELECTION-REQUEST libecore-x _sint)
  (def-extern ECORE-X-EVENT-SELECTION-NOTIFY libecore-x _sint)
  (def-extern ECORE-X-EVENT-WINDOW-STATE _sint)
  (def-extern ECORE-X-EVENT-CLIENT-MESSAGE libecore-x _sint)
  (def-extern ECORE-X-EVENT-WINDOW-SHAPE libecore-x _sint)
  
  (def-extern ECORE-X-EVENT-WINDOW-DELETE-REQUEST libecore-x _sint)
  (def-extern ECORE-X-EVENT-WINDOW-PROP-TITLE-CHANGE libecore-x _sint)
  (def-extern ECORE-X-EVENT-WINDOW-PROP-VISIBLE-TITLE-CHANGE libecore-x _sint)
  (def-extern ECORE-X-EVENT-WINDOW-PROP-ICON-NAME-CHANGE libecore-x _sint)
  (def-extern ECORE-X-EVENT-WINDOW-PROP-VISIBLE-ICON-NAME-CHANGE libecore-x _sint)
  (def-extern ECORE-X-EVENT-WINDOW-PROP-CLIENT-MACHINE-CHANGE libecore-x _sint)
  (def-extern ECORE-X-EVENT-WINDOW-PROP-NAME-CLASS-CHANGE libecore-x _sint)
  (def-extern ECORE-X-EVENT-WINDOW-PROP-PID-CHANGE libecore-x _sint)
  (def-extern ECORE-X-EVENT-WINDOW-PROP-DESKTOP-CHANGE libecore-x _sint)
  
  (def-extern ECORE-X-EVENT-XDND-ENTER libecore-x _sint)
  (def-extern ECORE-X-EVENT-XDND-POSITION libecore-x _sint)
  (def-extern ECORE-X-EVENT-XDND-STATUS libecore-x _sint)
  (def-extern ECORE-X-EVENT-XDND-LEAVE libecore-x _sint)
  (def-extern ECORE-X-EVENT-XDND-DROP libecore-x _sint)
  (def-extern ECORE-X-EVENT-XDND-FINISHED libecore-x _sint)
  
  (def-extern ECORE-X-MODIFIER-SHIFT libecore-x _sint)
  (def-extern ECORE-X-MODIFIER-CTRL libecore-x _sint)
  (def-extern ECORE-X-MODIFIER-ALT libecore-x _sint)
  (def-extern ECORE-X-MODIFIER-WIN libecore-x _sint)
  
  (def-extern ECORE-X-LOCK-SCROLL libecore-x _sint)
  (def-extern ECORE-X-LOCK-NUM libecore-x _sint)
  (def-extern ECORE-X-LOCK-CAPS libecore-x _sint)


  ;;Functions
  (defecore-x* ecore-x-init : _string -> _sint)
  (defecore-x* ecore-x-shutdown : -> _sint)
  (defecore-x* ecore-x-disconnect : -> _sint)
  
  (defecore-x* ecore-x-display-get : -> _EcoreXDisplay)
  (defecore-x* ecore-x-fd-get : -> _sint)
  (defecore-x* ecore-x-double-click-time-set : _double -> _void)
  (defecore-x* ecore-x-double-click-time-get : -> _double)
  (defecore-x* ecore-x-flush : -> _void)
  (defecore-x* ecore-x-sync : -> _void)
  (defecore-x* ecore-x-killall : _EcoreXWindow -> _void)
  (defecore-x* ecore-x-kill : _EcoreXWindow -> _void)
  (defecore-x* ecore-x-current-time-get : -> _EcoreXTime)
  (defecore-x* ecore-x-error-handler-set :
    (_fun _pointer -> _cbvoid) _pointer
    -> _void)
  (defecore-x* ecore-x-io-error-handler-set :
    (_fun _pointer -> _cbvoid) _pointer
    -> _void)
  (defecore-x* ecore-x-error-request-get : -> _sint)
  (defecore-x* ecore-x-error-code-get : -> _sint)
  (defecore-x* ecore-x-event-mask-set :
    _EcoreXWindow _EcoreXEventMask
    -> _void)
  (defecore-x* ecore-x-event-mask-unset :
    _EcoreXWindow _EcoreXEventMask
    -> _void)
  
;  (defecore-x* ecore-x-selection-primary-set :
;    _EcoreXWindow _pointer _sint
;    -> _sint) ;FIX
  (defecore-x* ecore-x-selection-primary-clear : -> _sint)
  
;  (defecore-x* ecore-x-selection-secondary-set :
;    _EcoreXWindow _pointer _sint
;    -> _sint) ;FIX
  (defecore-x* ecore-x-selection-secondary-clear : -> _sint)
  
;  (defecore-x* ecore-x-selection-xdnd-set :
;    _EcoreXWindow _pointer _sint
;    -> _sint) ;FIX
  (defecore-x* ecore-x-selection-xdnd-clear : -> _sint)
  
;  (defecore-x* ecore-x-selection-clipboard-set :
;    _EcoreXWindow _pointer _sint
;    -> _sint) ;FIX
  (defecore-x* ecore-x-selection-clipboard-clear : -> _sint)
  
  (defecore-x* ecore-x-selection-primary-request :
    _EcoreXWindow _string
    -> _void)
#|  (defecore-x* ecore-x-selection-primary-request-data-get :
    (o_buf : (_ptr o _pointer))
    (o_size : (_ptr o _sint))
    -> _void) ;FIX|#
  
  (defecore-x* ecore-x-selection-secondary-request :
    _EcoreXWindow _string
    -> _void)
#|  (defecore-x* ecore-x-selection-secondary-request-data-get :
    (o_buf : (_ptr o _pointer))
    (o_size : (_ptr o _sint))
    -> _void) ;FIX|#

  (defecore-x* ecore-x-selection-xdnd-request :
    _EcoreXWindow _string
    -> _void)
#|  (defecore-x* ecore-x-selection-xdnd-request-data-get :
    (o_buf : (_ptr o _pointer))
    (o_size : (_ptr o _sint))
    -> _void) ;FIX|#
  
  (defecore-x* ecore-x-selection-clipboard-request :
    _EcoreXWindow _string
    -> _void)
#|  (defecore-x* ecore-x-selection-clipboard-request-data-get :
    (o_buf : (_ptr o _pointer))
    (o_size : (_ptr o _sint))
    -> _void) ;FIX|#

;  (defecore-x* ecore-x-selection-converter-add :
;    _string (_fun _string _pointer _sint _pointer _pointer -> _sint)
;    -> _void) ;FIX
;  (defecore-x* ecore-x-selection-converter-atom-add :
;    _EcoreXAtom (_fun _string _pointer _sint _pointer _pointer -> _sint)
;    -> _void) ;FIX
  (defecore-x* ecore-x-selection-converter-del : _string -> _void)
  (defecore-x* ecore-x-selection-converter-atom-del : _EcoreXAtom -> _void)
    
;  (defecore-x* ecore-x-selection-parser-add :
;    _string (_fun _string _pointer _sint -> _pointer)
;    -> _void) ;FIX
  (defecore-x* ecore-x-selection-parser-del : _string -> _void)
  
  (defecore-x* ecore-x-dnd-aware-set : _EcoreXWindow _bool -> _void)
  (defecore-x* ecore-x-dnd-version-get : _EcoreXWindow -> _sint)
  (defecore-x* ecore-x-dnd-type-isset? : _EcoreXWindow _string -> _bool)
  (defecore-x* ecore-x-dnd-type-set : _EcoreXWindow _string _bool -> _void)
;  (defecore-x* ecore-x-dnd-begin : _EcoreXWindow _pointer _sint -> _sint) ;FIX
  (defecore-x* ecore-x-dnd-drop : -> _void)
  (defecore-x* ecore-x-dnd-send-status :
    _sint _sint _EcoreXRectangle _EcoreXAtom
    -> _void)
  (defecore-x* ecore-x-dnd-send-finished : -> _void)
  
  (defecore-x* ecore-x-window-new :
    _EcoreXWindow _sint _sint _sint _sint
    -> _EcoreXWindow)
  (defecore-x* ecore-x-window-override-new :
    _EcoreXWindow _sint _sint _sint _sint
    -> _EcoreXWindow)
  (defecore-x* ecore-x-window-input-new :
    _EcoreXWindow _sint _sint _sint _sint
    -> _EcoreXWindow)
  
  (defecore-x* ecore-x-window-configure :
    _EcoreXWindow _EcoreXWindowConfigureMask _sint _sint _sint _sint
    _sint _EcoreXWindow _sint
    -> _void)
  
  (defecore-x* ecore-x-window-cursor-set :
    _EcoreXWindow _EcoreXCursor
    -> _void)
  
  (defecore-x* ecore-x-window-del : _EcoreXWindow -> _void)
  (defecore-x* ecore-x-window-delete-request-send : _EcoreXWindow -> _void)
  (defecore-x* ecore-x-window-show : _EcoreXWindow -> _void)
  (defecore-x* ecore-x-window-hide : _EcoreXWindow -> _void)
  (defecore-x* ecore-x-window-move : _EcoreXWindow _sint _sint -> _void)
  (defecore-x* ecore-x-window-resize : _EcoreXWindow _sint _sint -> _void)
  (defecore-x* ecore-x-window-move-resize :
    _EcoreXWindow _sint _sint _sint _sint
    -> _void)
  (defecore-x* ecore-x-window-focus : _EcoreXWindow -> _void)
  (defecore-x* ecore-x-window-focus-at-time :
    _EcoreXWindow _EcoreXTime
    -> _void)
  (defecore-x* ecore-x-window-focus-get : -> _EcoreXWindow)
  (defecore-x* ecore-x-window-raise : _EcoreXWindow -> _void)
  (defecore-x* ecore-x-window-lower : _EcoreXWindow -> _void)
  (defecore-x* ecore-x-window-reparent :
    _EcoreXWindow _EcoreXWindow _sint _sint
    -> _void)
  (defecore-x* ecore-x-window-size-get :
    _EcoreXWindow (o_w : (_ptr o _sint)) (o_h : (_ptr o _sint))
    -> _void
    -> (list o_w o_h))
  (defecore-x* ecore-x-window-geometry-get :
    _EcoreXWindow
    (o_x : (_ptr o _sint)) (o_y : (_ptr o _sint))
    (o_w : (_ptr o _sint)) (o_h : (_ptr o _sint))
    -> _void
    -> (list o_x o_y o_w o_h))
  (defecore-x* ecore-x-window-border-width-get : _EcoreXWindow -> _sint)
  (defecore-x* ecore-x-window-border-width-set : _EcoreXWindow _sint -> _void)
  (defecore-x* ecore-x-window-depth-get : _EcoreXWindow -> _sint)
  (defecore-x* ecore-x-window-cursor-show : _EcoreXWindow _bool -> _void)
  (defecore-x* ecore-x-window-defaults-set : _EcoreXWindow -> _void)
  (defecore-x* ecore-x-window-visible-get : _EcoreXWindow -> _bool)
  (defecore-x* ecore-x-window-at-xy-get : _sint _sint -> _EcoreXWindow)
  (defecore-x* ecore-x-window-parent-get : _EcoreXWindow -> _EcoreXWindow)
  (defecore-x* ecore-x-window-background-color-set :
    _EcoreXWindow _ushort  _ushort _ushort
    -> _void)
  (defecore-x* ecore-x-window-gravity-set :
    _EcoreXWindow _EcoreXGravity
    -> _void)
  (defecore-x* ecore-x-window-pixel-gravity-set :
    _EcoreXWindow _EcoreXGravity
    -> _void)

  (defecore-x* ecore-x-window-prop-any-type : -> _EcoreXAtom)
;  (defecore-x* ecore-x-window-prop-property-set :
;    _EcoreXWindow _EcoreXAtom _EcoreXAtom _sint _pointer _sint
;    -> _void) ;FIX
;  (defecore-x* ecore-x-window-prop-property-get :
;    _EcoreXWindow _EcoreXAtom _EcoreXAtom _sint
;    (o_data : (_ptr o _pointer)) (o_size : (_ptr o _sint))
;    -> (o_ret : _sint)
;    -> (list o_ret o_data o_size)) ;FIX
  
;  (defecore-x* ecore-x-window-prop-card32-set :
;    _EcoreXWindow _EcoreXAtom
;    (i_val : (_vector i _uint)) (_uint = (vector-length i_val))
;    -> _void) ;FIX
#|  (defecore-x* ecore-x-window-prop-card32-get :
    _EcoreXWindow _EcoreXAtom
    (o_val : (_list o _uint i_len)) (i_len : _uint = (length o_val))
    -> (o_ret : _sint)
    -> (list o_ret o_val)) ;FIX|#
  
  (defecore-x* ecore-x-window-prop-property-del :
    _EcoreXWindow _EcoreXAtom
    -> _void)
  
  (defecore-x* ecore-x-window-prop-string-set :
    _EcoreXWindow _EcoreXAtom _string
    -> _void)
  (defecore-x* ecore-x-window-prop-string-get :
    _EcoreXWindow _EcoreXAtom
    -> _string/utf-8/free)
  
  (defecore-x* ecore-x-window-prop-title-set : _EcoreXWindow _string -> _void)
  (defecore-x* ecore-x-window-prop-title-get :
    _EcoreXWindow
    -> _string/utf-8/free)
  
  (defecore-x* ecore-x-window-prop-visible-title-set :
    _EcoreXWindow _string
    -> _void)
  (defecore-x* ecore-x-window-prop-visible-title-get :
    _EcoreXWindow
    -> _string/utf-8/free)
  
  (defecore-x* ecore-x-window-prop-visible-icon-name-set :
    _EcoreXWindow _string
    -> _void)
  (defecore-x* ecore-x-window-prop-visible-icon-name-get :
    _EcoreXWindow
    -> _string/utf-8/free)
  
  (defecore-x* ecore-x-window-prop-pid-get : _EcoreXWindow -> _pid-t)
  
  (defecore-x* ecore-x-window-prop-protocol-list-get :
    _EcoreXWindow (o_num : (_ptr o _sint))
    -> (_list/free _EcoreXWMProtocol o_num))
  
  (defecore-x* ecore-x-window-prop-sticky-set : _EcoreXWindow _bool -> _void)
  
  (defecore-x* ecore-x-window-prop-input-mode-set :
    _EcoreXWindow _EcoreXWindowInputMode
    -> _sint)
  
  (defecore-x* ecore-x-window-prop-initial-state-set :
    _EcoreXWindow _EcoreXWindowInputMode
    -> _sint)
  
  (defecore-x* ecore-x-window-prop-min-size-set :
    _EcoreXWindow _sint _sint
    -> _void)
  (defecore-x* ecore-x-window-prop-max-size-set :
    _EcoreXWindow _sint _sint
    -> _void)
  (defecore-x* ecore-x-window-prop-base-size-set :
    _EcoreXWindow _sint _sint
    -> _void)
  (defecore-x* ecore-x-window-prop-step-size-set :
    _EcoreXWindow _sint _sint
    -> _void)
  
  (defecore-x* ecore-x-window-prop-xy-set :
    _EcoreXWindow _sint _sint
    -> _void)
  
  (defecore-x* ecore-x-window-prop-borderless-set :
    _EcoreXWindow _bool
    -> _void)
  (defecore-x* ecore-x-window-prop-borderless-get : _EcoreXWindow -> _bool)
  
  (defecore-x* ecore-x-window-prop-layer-set : _EcoreXWindow _sint -> _bool)
  
  (defecore-x* ecore-x-window-prop-withdrawn-set :
    _EcoreXWindow _bool
    -> _void)
  
  (defecore-x* ecore-x-window-prop-desktop-request :
    _EcoreXWindow _slong
    -> _void)
  
  (defecore-x* ecore-x-window-prop-state-request :
    _EcoreXWindow _EcoreXWindowState _sint
    -> _void)
  
  (defecore-x* ecore-x-window-prop-desktop-set : _EcoreXWindow _slong -> _void)
  (defecore-x* ecore-x-window-prop-desktop-get : _EcoreXWindow -> _slong)
  
  (defecore-x* ecore-x-window-prop-window-type-set :
    _EcoreXWindow _EcoreXWindowType
    -> _void)
  
  (defecore-x* ecore-x-window-prop-window-opacity-set :
    _EcoreXWindow _sint
    -> _void)
  (defecore-x* ecore-x-window-prop-window-opacity-get : _EcoreXWindow -> _sint)
  
  (defecore-x* ecore-x-window-prop-state-set :
    _EcoreXWindow _EcoreXWindowState
    -> _void)
  (defecore-x* ecore-x-window-prop-state-isset? :
    _EcoreXWindow _EcoreXWindowState
    -> _bool)
  (defecore-x* ecore-x-window-prop-state-unset :
    _EcoreXWindow _EcoreXWindowState
    -> _void)
  
  (defecore-x* ecore-x-window-shape-mask-set :
    _EcoreXWindow _EcoreXPixmap
    -> _void)
  (defecore-x* ecore-x-window-shape-window-set :
    _EcoreXWindow _EcoreXWindow
    -> _void)
  (defecore-x* ecore-x-window-shape-window-set-xy :
    _EcoreXWindow _EcoreXWindow _sint _sint
    -> _void)
  (defecore-x* ecore-x-window-shape-rectangle-set :
    _EcoreXWindow _sint _sint _sint _sint
    -> _void)
  (defecore-x* ecore-x-window-shape-rectangles-set :
    _EcoreXWindow
    (i_rects : (_list i _EcoreXRectangle))
    (_sint = (length i_rects))
    -> _void)
  (defecore-x* ecore-x-window-shape-window-add :
    _EcoreXWindow _EcoreXWindow
    -> _void)
  (defecore-x* ecore-x-window-shape-window-add-xy :
    _EcoreXWindow _EcoreXWindow _sint _sint
    -> _void)
  (defecore-x* ecore-x-window-shape-rectangle-add :
    _EcoreXWindow _sint _sint _sint _sint
    -> _void)
  (defecore-x* ecore-x-window-shape-rectangle-clip :
    _EcoreXWindow _sint _sint _sint _sint
    -> _void)
  (defecore-x* ecore-x-window-shape-rectangles-add :
    _EcoreXWindow
    (i_rects : (_list i _EcoreXRectangle))
    (_sint = (length i_rects))
    -> _void)
  (defecore-x* ecore-x-window-shape-rectangles-get :
    _EcoreXWindow
    (o_num : (_ptr o _sint))
    -> (_list/finalize _EcoreXRectangle o_num))
  (defecore-x* ecore-x-window-shape-events-select :
    _EcoreXWindow _bool
    -> _void)
  
  (defecore-x* ecore-x-pixmap-new :
    _EcoreXWindow _sint _sint _sint
    -> _EcoreXPixmap)
  (defecore-x* ecore-x-pixmap-del : _EcoreXPixmap -> _void)
  (defecore-x* ecore-x-pixmap-paste :
    _EcoreXPixmap _EcoreXDrawable _EcoreXGC _sint _sint _sint _sint _sint _sint
    -> _void)
  (defecore-x* ecore-x-pixmap-geometry-get :
    _EcoreXPixmap
    (o_x : (_ptr o _sint))
    (o_y : (_ptr o _sint))
    (o_w : (_ptr o _sint))
    (o_h : (_ptr o _sint))
    -> _void
    -> (list o_x o_y o_w o_h))
  (defecore-x* ecore-x-pixmap-depth-get : _EcoreXPixmap -> _sint)
  
  (defecore-x* ecore-x-gc-new : _EcoreXDrawable -> _EcoreXGC)
  (defecore-x* ecore-x-gc-del : _EcoreXGC -> _void)
  
  (defecore-x* ecore-x-client-message32-send :
    _EcoreXWindow _EcoreXAtom _EcoreXEventMask
    _slong _slong _slong _slong _slong
    -> _bool)
  (defecore-x* ecore-x-client-message8-send :
    _EcoreXWindow _EcoreXAtom _pointer _sint
    -> _bool)
  
  ;; FIXME: these funcs need categorising
  (defecore-x* ecore-x-drawable-geometry-get :
    _EcoreXDrawable
    (o_x : (_ptr o _sint))
    (o_y : (_ptr o _sint))
    (o_w : (_ptr o _sint))
    (o_h : (_ptr o _sint))
    -> _void
    -> (list o_x o_y o_w o_h))
  (defecore-x* ecore-x-drawable-border-width-get : _EcoreXDrawable -> _sint)
  (defecore-x* ecore-x-drawable-depth-get : _EcoreXDrawable -> _sint)
  
  (defecore-x* ecore-x-window-root-list :
    (o_num : (_ptr o _sint))
    -> (_list/free _EcoreXWindow o_num))
  (defecore-x* ecore-x-window-root-first-get : -> _EcoreXWindow)
  
  (defecore-x* ecore-x-window-manage : _EcoreXWindow -> _bool)
  (defecore-x* ecore-x-window-container-manage : _EcoreXWindow -> _bool)
  (defecore-x* ecore-x-window-client-manage : _EcoreXWindow -> _bool)
  
  (defecore-x* ecore-x-window-sniff : _EcoreXWindow -> _void)
  (defecore-x* ecore-x-window-client-sniff : _EcoreXWindow -> _void)
  
  (defecore-x* ecore-x-atom-get : _string -> _EcoreXAtom)
  ;; END
  
  (defecore-x* ecore-x-icccm-init : -> _void)
  
  (defecore-x* ecore-x-icccm-state-set :
    _EcoreXWindow _EcoreXWindowStateHint
    -> _void)
  (defecore-x* ecore-x-icccm-state-get :
    _EcoreXWindow
    -> _EcoreXWindowStateHint)
  
  (defecore-x* ecore-x-icccm-delete-window-send :
    _EcoreXWindow _EcoreXTime
    -> _void)
  
  (defecore-x* ecore-x-icccm-take-focus-send :
    _EcoreXWindow _EcoreXTime
    -> _void)
  
  (defecore-x* ecore-x-icccm-save-yourself-send :
    _EcoreXWindow _EcoreXTime
    -> _void)
  
  (defecore-x* ecore-x-icccm-move-resize-send :
    _EcoreXWindow _sint _sint _sint _sint
    -> _void)
  
  (defecore-x* ecore-x-icccm-hints-set :
    _EcoreXWindow _bool _EcoreXWindowStateHint _EcoreXPixmap _EcoreXPixmap
    _EcoreXWindow _EcoreXWindow _bool
    -> _void)
  (defecore-x* ecore-x-icccm-hints-get :
    _EcoreXWindow
    (o_accepts-focus : (_ptr o _bool))
    (o_initial-state : (_ptr o _EcoreXWindowStateHint))
    (o_icon-pixmap : (_ptr o _EcoreXPixmap))
    (o_icon-mask : (_ptr o _EcoreXPixmap))
    (o_icon-window : (_ptr o _EcoreXWindow))
    (o_window-group : (_ptr o _EcoreXWindow))
    (o_is-urgent : (_ptr o _bool))
    -> (o_success : _bool)
    -> (if o_success
           (list o_accepts-focus o_initial-state
                 o_icon-pixmap o_icon-mask
                 o_icon-window o_window-group
                 o_is-urgent)
           #f))
  
  (defecore-x* ecore-x-icccm-size-pos-hints-set :
    _EcoreXWindow _bool _EcoreXGravity _sint _sint _sint _sint
    _sint _sint _sint _sint _double _double
    -> _void)
  (defecore-x* ecore-x-icccm-size-pos-hints-get :
    _EcoreXWindow
    (o_request-pos : (_ptr o _bool))
    (o_gravity : (_ptr o _EcoreXGravity))
    (o_min-w : (_ptr o _sint)) (o_min-h : (_ptr o _sint))
    (o_max-w : (_ptr o _sint)) (o_max-h : (_ptr o _sint))
    (o_base-w : (_ptr o _sint)) (o_base-h : (_ptr o _sint))
    (o_step-x : (_ptr o _sint)) (o_step-y : (_ptr o _sint))
    (o_min-aspect : (_ptr o _double)) (o_max-aspect : (_ptr o _double))
    -> (o_success : _bool)
    -> (if o_success
           (list o_request-pos o_gravity
                 o_min-w o_min-h o_max-w o_max-h o_base-w o_base-h
                 o_step-x o_step-y o_min-aspect o_max-aspect)
           #f))
  
  (defecore-x* ecore-x-icccm-title-set : _EcoreXWindow _string -> _void)
  (defecore-x* ecore-x-icccm-title-get : _EcoreXWindow -> _string/utf-8/free)
  
  (defecore-x* ecore-x-icccm-protocol-set :
    _EcoreXWindow _EcoreXWMProtocol _bool
    -> _void)
  (defecore-x* ecore-x-icccm-protocol-isset? :
    _EcoreXWindow _EcoreXWMProtocol
    -> _bool)
  
  (defecore-x* ecore-x-icccm-name-class-set :
    _EcoreXWindow _string _string
    -> _void)

  (defecore-x* ecore-x-icccm-name-class-get :
    _EcoreXWindow
    (o_name : (_ptr o _string/utf-8/free))
    (o_class : (_ptr o _string/utf-8/free))
    -> _void
    -> (list o_name o_class))

  (defecore-x* ecore-x-icccm-client-machine-get :
    _EcoreXWindow
    -> _string/utf-8/free)
  
  (defecore-x* ecore-x-icccm-command-set :
    _EcoreXWindow (_sint = (length i_argv)) (i_argv : (_list i _string))
    -> _void)
  (defecore-x* ecore-x-icccm-command-get :
    _EcoreXWindow (o_argc : (_ptr o _sint))
    (o_argv : (_ptr o (_list o _string/utf-8/free o_argc)))
    -> _void
    -> o_argv)
  
  (defecore-x* ecore-x-icccm-icon-name-set :
    _EcoreXWindow _string
    -> _void)
  (defecore-x* ecore-x-icccm-icon-name-get :
    _EcoreXWindow
    -> _string/utf-8/free)
  
  (defecore-x* ecore-x-icccm-colormap-window-set :
    _EcoreXWindow _EcoreXWindow
    -> _void)
  (defecore-x* ecore-x-icccm-colormap-window-unset :
    _EcoreXWindow _EcoreXWindow
    -> _void)
  
  (defecore-x* ecore-x-icccm-transient-for-set :
    _EcoreXWindow _EcoreXWindow
    ->  _void)
  (defecore-x* ecore-x-icccm-transient-for-unset : _EcoreXWindow -> _void)
  (defecore-x* ecore-x-icccm-transient-for-get :
    _EcoreXWindow
    -> _EcoreXWindow)
  
  (defecore-x* ecore-x-icccm-window-role-set :
    _EcoreXWindow _string
    -> _void)
  (defecore-x* ecore-x-icccm-window-role-get :
    _EcoreXWindow
    -> _string/utf-8/free)
  
  (defecore-x* ecore-x-icccm-client-leader-set :
    _EcoreXWindow _EcoreXWindow
    -> _void)
  (defecore-x* ecore-x-icccm-client-leader-get :
    _EcoreXWindow
    -> _EcoreXWindow)
  
  (defecore-x* ecore-x-mwm-hints-get :
    _EcoreXWindow
    (o_fhint : (_ptr o _EcoreXMWMHintFunc))
    (o_dhint : (_ptr o _EcoreXMWMHintDecor))
    (o_ihint : (_ptr o _EcoreXMWMHintInput))
    -> (o_success : _bool)
    -> (if o_success
           (list o_fhint o_dhint o_ihint)
           #f))
  
  (defecore-x* ecore-x-netwm-init : -> _void)
  
  (defecore-x* ecore-x-netwm-wm-identify :
    _EcoreXWindow _EcoreXWindow _string
    -> _void)
  
  (defecore-x* ecore-x-netwm-desk-count-set : _EcoreXWindow _uint -> _void)
  
  (defecore-x* ecore-x-netwm-desk-roots-set :
    _EcoreXWindow
    (_uint = (length i_vroots))
    (i_vroots : (_list i _EcoreXWindow))
    -> _void)
  
  (defecore-x* ecore-x-netwm-desk-names-set :
    _EcoreXWindow
    (_uint = (length i_names))
    (i_names : (_list i _string))
    -> _void)
  
  (defecore-x* ecore-x-netwm-desk-size-set :
    _EcoreXWindow _uint _uint
    -> _void)
  
  (defecore-x* ecore-x-netwm-desk-workareas-set :
    _EcoreXWindow
    (_uint = (length i_areas))
    (i_areas : (_list i _uint))
    -> _void)
  
  (defecore-x* ecore-x-netwm-desk-current-set : _EcoreXWindow _uint -> _void)
  
  (defecore-x* ecore-x-netwm-desk-viewports-set :
    _EcoreXWindow
    (_uint = (length i_origins))
    (i_origins : (_list i _uint))
    -> _void)
  
  (defecore-x* ecore-x-netwm-desk-layout-set :
    _EcoreXWindow _sint _sint _sint _sint
    -> _void)
  
  (defecore-x* ecore-x-netwm-showing-desktop-set :
    _EcoreXWindow _bool
    -> _void)
  
  (defecore-x* ecore-x-netwm-client-list-set :
    _EcoreXWindow
    (_uint = (length i_p-clients))
    (i_p-clients : (_list i _EcoreXWindow))
    -> _void)
  
  (defecore-x* ecore-x-netwm-client-list-stacking-set :
    _EcoreXWindow
    (_uint = (length i_p-clients))
    (i_p-clients : (_list i _EcoreXWindow))
    -> _void)
  
  (defecore-x* ecore-x-netwm-client-active-set :
    _EcoreXWindow _EcoreXWindow
    -> _void)
  
  (defecore-x* ecore-x-netwm-name-set : _EcoreXWindow _string -> _void)
  (defecore-x* ecore-x-netwm-name-get : _EcoreXWindow -> _string/utf-8/free)
  
  (defecore-x* ecore-x-netwm-visible-name-set : _EcoreXWindow _string -> _void)
  (defecore-x* ecore-x-netwm-visible-name-get :
    _EcoreXWindow
    -> _string/utf-8/free)
  
  (defecore-x* ecore-x-netwm-icon-name-set :
    _EcoreXWindow _string
    -> _void)
  (defecore-x* ecore-x-netwm-icon-name-get :
    _EcoreXWindow
    -> _string/utf-8/free)
  
  (defecore-x* ecore-x-netwm-visible-icon-name-set :
    _EcoreXWindow _string
    -> _void)
  (defecore-x* ecore-x-netwm-visible-icon-name-get :
    _EcoreXWindow
    -> _string/utf-8/free)
  
  (defecore-x* ecore-x-netwm-desktop-set : _EcoreXWindow _uint -> _void)
  (defecore-x* ecore-x-netwm-desktop-get :
    _EcoreXWindow (o_desk : (_ptr o _uint))
    -> (o_success : _bool)
    -> (if o_success
           o_desk
           #f))
  
  (defecore-x* ecore-x-netwm-strut-set :
    _EcoreXWindow _sint _sint _sint _sint
    -> _void)
  (defecore-x* ecore-x-netwm-strut-get :
    _EcoreXWindow
    (o_left : (_ptr o _sint)) (o_right : (_ptr o _sint))
    (o_top : (_ptr o _sint)) (o_bottom : (_ptr o _sint))
    -> (o_success : _bool)
    -> (if o_success
           (list o_left o_right o_top o_bottom)
           #f))
  
  (defecore-x* ecore-x-netwm-strut-partial-set :
    _EcoreXWindow
    _sint _sint _sint _sint
    _sint _sint _sint _sint
    _sint _sint _sint _sint
    -> _void)
  (defecore-x* ecore-x-netwm-strut-partial-get :
    _EcoreXWindow
    (o_left : (_ptr o _sint)) (o_right : (_ptr o _sint))
    (o_top : (_ptr o _sint)) (o_bottom : (_ptr o _sint))
    (o_left-start-y : (_ptr o _sint)) (o_left-end-y : (_ptr o _sint))
    (o_right-start-y : (_ptr o _sint)) (o_right-end-y : (_ptr o _sint))
    (o_top-start-x : (_ptr o _sint)) (o_top-end-x : (_ptr o _sint))
    (o_bottom-start-x : (_ptr o _sint)) (o_bottom-end-x : (_ptr o _sint))
    -> (o_success : _bool)
    -> (if o_success
           (list o_left o_right o_top o_bottom
                 o_left-start-y o_left-end-y o_right-start-y o_right-end-y
                 o_top-start-x o_top-end-x o_bottom-start-x o_bottom-end-x)))
  
  (defecore-x* ecore-x-netwm-icon-geometry-set :
    _EcoreXWindow _sint _sint _sint _sint
    -> _void)
  (defecore-x* ecore-x-netwm-icon-geometry-get :
    _EcoreXWindow
    (o_x : (_ptr o _sint))
    (o_y : (_ptr o _sint))
    (o_width : (_ptr o _sint))
    (o_height : (_ptr o _sint))
    -> (o_success : _bool)
    -> (if o_success
           (list o_x o_y o_width o_height)
           #f))

  (defecore-x* ecore-x-netwm-pid-set : _EcoreXWindow _sint -> _void)
  (defecore-x* ecore-x-netwm-pid-get : _EcoreXWindow -> _sint)
  
  (defecore-x* ecore-x-netwm-handled-icons-set : _EcoreXWindow -> _void)
  (defecore-x* ecore-x-netwm-handled-icons-get : _EcoreXWindow -> _bool)
  
  (defecore-x* ecore-x-netwm-user-time-set : _EcoreXWindow _sint -> _void)
  (defecore-x* ecore-x-netwm-user-time-get :
    _EcoreXWindow (o_time : (_ptr o _sint))
    -> (o_success : _bool)
    -> (if o_success
           o_time
           #f))
  
  (defecore-x* ecore-x-netwm-window-state-set :
    _EcoreXWindow _EcoreXWindowState _bool
    -> _void)
  (defecore-x* ecore-x-netwm-window-state-isset? :
    _EcoreXWindow _EcoreXWindowState
    -> _bool)
  
  (defecore-x* ecore-x-netwm-window-type-set :
    _EcoreXWindow _EcoreXWindowType
    -> _void)
  (defecore-x* ecore-x-netwm-window-type-get :
    _EcoreXWindow
    -> _EcoreXWindowType)
  
  (defecore-x* ecore-x-netwm-allowed-action-isset? :
    _EcoreXWindow _EcoreXAction
    -> _bool)
  (defecore-x* ecore-x-netwm-allowed-action-set :
    _EcoreXWindow _EcoreXAction _bool
    -> _bool)
  
  (defecore-x* ecore-x-netwm-opacity-set : _EcoreXWindow _uint -> _void)
  (defecore-x* ecore-x-netwm-opacity-get :
    _EcoreXWindow (o_opacity : (_ptr o _uint))
    -> (o_success : _bool)
    -> (if o_success
           o_opacity
           #f))
  
  (defecore-x* ecore-x-netwm-frame-size-set :
    _EcoreXWindow _sint _sint _sint _sint
    -> _void)
  (defecore-x* ecore-x-netwm-frame-size-get :
    _EcoreXWindow
    (o_fl : (_ptr o _sint))
    (o_fr : (_ptr o _sint))
    (o_ft : (_ptr o _sint))
    (o_fb : (_ptr o _sint))
    -> (o_success : _bool)
    -> (if o_success
           (list o_fl o_fr o_ft o_fb)
           #f))

  (defecore-x* ecore-x-e-init : -> _void)
  
  (defecore-x* ecore-x-e-frame-size-set :
    _EcoreXWindow _sint _sint _sint _sint
    -> _void)
  
  (defecore-x* ecore-x-xinerama-screen-count-get : -> _sint)
  
  (defecore-x* ecore-x-xinerama-screen-geometry-get :
    _sint
    (o_x : (_ptr o _sint))
    (o_y : (_ptr o _sint))
    (o_w : (_ptr o _sint))
    (o_h : (_ptr o _sint))
    -> (o_success : _bool)
    -> (if o_success
           (list o_x o_y o_w o_h)
           #f))
  
  (define-cstruct _EcoreXWindowAttributes
    ((root _EcoreXWindow) (x _sint) (y _sint) (w _sint) (h _sint)
     (border _sint) (depth _sint)
     (flags (_bitmask '(visible    = #o01
                        viewable   = #o02
                        overide    = #o04
                        input-only = #o10
                        save-under = #o20) _byte))
     (event-mask-mine _EcoreXEventMask)
     (event-mask-all _EcoreXEventMask)
     (event-mask-no-propagate _EcoreXEventMask)
     (window-gravity _EcoreXGravity)
     (pixel-gravity _EcoreXGravity)
     (colormap _EcoreXColormap)))

  (defecore-x* ecore-x-window-attributes-get :
    _EcoreXWindow (o_att : (_ptr o _EcoreXWindowAttributes))
    -> (o_success : _bool)
    -> (if o_success
           o_att
           #f))
  
  (defecore-x* ecore-x-window-save-set-add : _EcoreXWindow -> _void)
  (defecore-x* ecore-x-window-save-set-del : _EcoreXWindow -> _void)
  
  (defecore-x* ecore-x-window-children-get :
    _EcoreXWindow (o_num : (_ptr o _sint))
    -> (_list/free _EcoreXWindow o_num))
  
  (defecore-x* ecore-x-cursor-color-supported-get : -> _bool)
  
  (defecore-x* ecore-x-cursor-new :
    (pre: (when (< (vector-length i_pixels) (* i_w i_h))
            (error "Not enough pixels on vector.")))
    (post: (register-finalizer o_cursor ecore-x-cursor-free))
    _EcoreXWindow (i_pixels : (_vector i _sint))
    (i_w : _sint) (i_h : _sint) _sint _sint
    ->  (o_cursor : _EcoreXCursor))
  (defecore-x* ecore-x-cursor-free : _EcoreXCursor -> _void)
  (defecore-x* ecore-x-cursor-shape-get : _EcoreXCursor -> _EcoreXCursor)
  
  (defecore-x* ecore-x-pointer-grab : _EcoreXWindow -> _sint)
  (defecore-x* ecore-x-pointer-confine-grab : _EcoreXWindow -> _sint)
  (defecore-x* ecore-x-pointer-ungrab : -> _void)
  (defecore-x* ecore-x-pointer-warp : _EcoreXWindow _sint _sint -> _void)
  
  (defecore-x* ecore-x-keyboard-grab : _EcoreXWindow -> _sint)
  (defecore-x* ecore-x-keyboard-ungrab : _EcoreXWindow -> _void)

  (defecore-x* ecore-x-grab : -> _void)
  (defecore-x* ecore-x-ungrab : -> _void)
  
  (defecore-x* ecore-x-passive-grab-replay-func-set :
    (_fun _scheme _sint _pointer -> _sint) _scheme
    -> _void)
  
  (defecore-x* ecore-x-window-button-grab :
    _EcoreXWindow _sint _EcoreXEventMask _sint _sint
    -> _void)
  (defecore-x* ecore-x-window-button-ungrab :
    _EcoreXWindow _sint _sint _sint
    -> _void)
 
  (defecore-x* ecore-x-window-key-grab :
    _EcoreXWindow _string _sint _sint
    -> _void)
  (defecore-x* ecore-x-window-key-ungrab :
    _EcoreXWindow _string _sint _sint
    -> _void)
  
  (defecore-x* ecore-x-focus-reset : -> _void)
  
  (defecore-x* ecore-x-events-allow-all : -> _void)
  
  (defecore-x* ecore-x-pointer-last-xy-get :
    (o_x : (_ptr o _sint)) (o_y : (_ptr o _sint))
    -> _void
    -> (list o_x o_y))
  
  (defecore-x* ecore-x-pointer-last-xy-get :
    _EcoreXWindow (o_x : (_ptr o _sint)) (o_y : (_ptr o _sint))
    -> _void
    -> (list o_x o_y))
  ) 
