(module evas mzscheme
  
  (require (lib "foreign.ss") 
           "efl-common.ss"
           "evas-types.ss")
  (unsafe!)
  (define libevas (ffi-lib "libevas"))
  
  (provide (struct evas-error ()))
  (define-struct (evas-error efl-error) ())

  (define-efl-exn-raiser evas)
  (define-efl-ffi-definer evas)
  
  (define _EvasCallbackType
    (_enum '(EVAS-CALLBACK-MOUSE-IN
	     EVAS-CALLBACK-MOUSE-OUT
             EVAS-CALLBACK-MOUSE-DOWN
             EVAS-CALLBACK-MOUSE-UP
             EVAS-CALLBACK-MOUSE-MOVE
             EVAS-CALLBACK-MOUSE-WHEEL
             EVAS-CALLBACK-FREE
             EVAS-CALLBACK-KEY-DOWN
             EVAS-CALLBACK-KEY-UP
             EVAS-CALLBACK-FOCUS-IN
             EVAS-CALLBACK-FOCUS-OUT
             EVAS-CALLBACK-SHOW
             EVAS-CALLBACK-HIDE
             EVAS-CALLBACK-MOVE
             EVAS-CALLBACK-RESIZE
             EVAS-CALLBACK-RESTACK)))

  (define _EvasButtonFlags
    (_enum '(EVAS-BUTTON-NONE = 0
             EVAS-BUTTON-DOUBLE-CLICK = 1
             EVAS-BUTTON-TRIPPLE-CLICK = 2)))
  
  (define _EvasLoadError
    (_enum '(EVAS-LOAD-ERROR-NONE = 0
             EVAS-LOAD-ERROR-GENERIC = 1
             EVAS-LOAD-ERROR-DOES-NOT-EXIST = 2
             EVAS-LOAD-ERROR-PERMISSION-DENIED 3
             EVAS-LOAD-ERROR-RESOURCE-ALLOCATION-FAILED = 4
             EVAS-LOAD-ERROR-CORRUPT-FILE = 5
             EVAS-LOAD-ERROR-UNKNOWN-FORMAT = 6)))
  
  (define _EvasAllocError
    (_enum '(EVAS-ALLOC-ERROR-NONE = 0
             EVAS-ALLOC-ERROR-FATAL = 1
             EVAS-ALLOC-ERROR-RECOVERED = 2)))
  
  (define _EvasPixelFormat
    (_enum '(EVAS-PIXEL-FORMAT-NONE = 0
             EVAS-PIXEL-FORMAT-ARGB32 = 1
             EVAS-PIXEL-FORMAT-YUV420P-601 = 2)))
  
  (define _EvasTextFlag
    (_enum '(EVAS-TEXT-INVALID = -1
             EVAS-TEXT-SPECIAL = -2)))
  
  
  (define-cstruct* _EvasRectangle ((x _sint) (y _sint) (w _sint) (h _sint)))
  (define-cstruct* _EvasSmartClass
    ((name _string)
     (add (_fun _EvasObject -> _cbvoid))
     (del (_fun _EvasObject -> _cbvoid))
     (layer-set (_fun _EvasObject _sint -> _cbvoid))
     (raise (_fun _EvasObject -> _cbvoid))
     (lower (_fun _EvasObject -> _cbvoid))
     (stack-above (_fun _EvasObject _EvasObject -> _cbvoid))
     (stack-below (_fun _EvasObject _EvasObject -> _cbvoid))
     (move (_fun _EvasObject _EvasCoord _EvasCoord -> _cbvoid))
     (resize (_fun _EvasObject _EvasCoord _EvasCoord -> _cbvoid))
     (show (_fun _EvasObject -> _cbvoid))
     (hide (_fun _EvasObject -> _cbvoid))
     (color-set (_fun _EvasObject _sint _sint _sint _sint -> _cbvoid))
     (clip-set (_fun _EvasObject _EvasObject -> _cbvoid))
     (clip-unset (_fun _EvasObject -> _cbvoid))
     (data _scheme)))
  (define-cstruct* _EvasPixelImportSource
    ((format _sint) (w _sint) (h _sint) (row _cvector)))
  (define-cstruct* _EvasEngineInfo ((magic _sint)))
  (define-cpointer-type _Display)
  (define-cpointer-type _Drawable)
  (define-cpointer-type _Visual)
  (define-cpointer-type _Pixmap)
  (define-cpointer-type _Colormap)
#|  (define-cstruct _struct-info-SoftwareX11
    ((display _Display) (drawable _Drawable) (mask _Pixmap) (visual _Visual)
     (colormap _Colormap) (depth _sint) (rotation _sint)
     (flags (_bitmask '(ALLOC-GRAYSCALE = #o1
                        DEBUG = #o2
                        SHAPE-DITHER = #o4) _sint))
     (alloc-colors-max _sint)))
  (define-cstruct  _struct-func-SoftwareX11
    ((best-visual-get _fpointer)
     (best-colomap-get _fpointer)
     (best-depth-get _fpointer)
     (performace-test _fpointer)
     (performance-free _fpointer)
     (performance-data-get _fpointer)
     (performance-key-get _fpointer)
     (performance-new _fpointer)
     (performance-build _fpointer)
     (performance-device-store _fpointer)))
  (define-cstruct (_EvasEngineInfoSoftwareX11 _EvasEngineInfo)
    ((info _struct-info-SoftwareX11)
     (func _struct-func-SoftwareX11)))|#
  (define-cstruct* (_EvasEngineInfoSoftwareX11 _EvasEngineInfo)
    ((info-display _Display) (info-drawable _Drawable)
     (info-mask _Pixmap) (info-visual _Visual)
     (info-colormap _Colormap) (info-depth _sint) (info-rotation _sint)
     (info-flags (_bitmask '(ALLOC-GRAYSCALE = #o1
                             DEBUG = #o2
                             SHAPE-DITHER = #o4) _sint))
     (info-alloc-colors-max _sint)
     (func-best-visual-get _fpointer)
     (func-best-colomap-get _fpointer)
     (func-best-depth-get _fpointer)
     (func-performace-test _fpointer)
     (func-performance-free _fpointer)
     (func-performance-data-get _fpointer)
     (func-performance-key-get _fpointer)
     (func-performance-new _fpointer)
     (func-performance-build _fpointer)
     (func-performance-device-store _fpointer)))
#|  (define-cstruct _struct-info-GLX11
    ((display _Display) (drawable _Drawable) (visual _Visual)
     (colormap _Colormap) (depth _sint)))
  (define-cstruct _struct-func-GLX11
    ((best-visual-get _fpointer)
     (best-colomap-get _fpointer)
     (best-depth-get _fpointer)))
  (define-cstruct (_EvasEngineInfoGLX11 _EvasEngineInfo)
    ((info _struct-info-GLX11)
     (func _struct-func-GLX11)))|#
  (define-cstruct* (_EvasEngineInfoGLX11 _EvasEngineInfo)
    ((info-display _Display) (info-drawable _Drawable)
     (info-visual _Visual) (info-colormap _Colormap) (info-depth _sint)
     (func-best-visual-get _fpointer)
     (func-best-colomap-get _fpointer)
     (func-best-depth-get _fpointer)))
#|  (define-cstruct _struct-info-FB
    ((virtual-terminal _sint) (device-number _sint)
     (refresh _sint) (rotation _sint)))
  (define-cstruct (_EvasEngineInfoFB _EvasEngineInfo)
    ((info _struct-info-FB)))|#
  (define-cstruct* (_EvasEngineInfoFB _EvasEngineInfo)
    ((info-virtual-terminal _sint) (info-device-number _sint)
     (info-refresh _sint) (info-rotation _sint)))
#|  (define-cstruct _struct-func-Buffer
    ((new-update-region _fpointer)
     (free-update-region _fpointer)))
  (define-cstruct _struct-info-Buffer
    ((depth-type _sint) (dest-buffer _pointer)
     (dest-buffer-row-bytes _sint)
     (flags (_bitmask '(USE-COLOR-KEY = #o1) _byte))
     (alpha-threshold _sint)
     (color-key-r _sint) (color-key-f _sint) (color-key-b _sint)
     (func _struct-func-Buffer)))
  (define-cstruct (_EvasEngineInfoBuffer _EvasEngineInfo)
    ((info _struct-info-Buffer)))|#
  (define-cstruct* (_EvasEngineInfoBuffer _EvasEngineInfo)
    ((info-depth-type _sint) (info-dest-buffer _pointer)
     (info-dest-buffer-row-bytes _sint)
     (info-flags (_bitmask '(USE-COLOR-KEY = #o1) _byte))
     (info-alpha-threshold _sint)
     (info-color-key-r _sint) (info-color-key-f _sint)
     (info-color-key-b _sint)
     (info-func-new-update-region _fpointer)
     (info-func-free-update-region _fpointer)))
   
;  (define-cstruct _struct-output ((x _sint) (y _sint)))
;  (define-cstruct _struct-canvas ((x _EvasCoord) (y _EvasCoord)))
  (define-cstruct* _EvasEventMouseDown
    ((button _sint) ;(output _struct-output) (canvas _struct-canvas)
     (output-x _sint) (output-y _sint)
     (canvas-x _EvasCoord) (canvas-y _EvasCoord)
     (data _scheme) (modifiers _EvasModifier) (locks _EvasLock)
     (flags _EvasButtonFlags)))
  (define-cstruct* _EvasEventMouseUp
    ((button _sint) ;(output _struct-output) (canvas _struct-canvas)
     (output-x _sint) (output-y _sint)
     (canvas-x _EvasCoord) (canvas-y _EvasCoord)
     (data _scheme) (modifiers _EvasModifier) (locks _EvasLock)
     (flags _EvasButtonFlags)))
  (define-cstruct* _EvasEventMouseIn
    ((button _sint) ;(output _struct-output) (canvas _struct-canvas)
     (output-x _sint) (output-y _sint)
     (canvas-x _EvasCoord) (canvas-y _EvasCoord)
     (data _scheme) (modifiers _EvasModifier) (locks _EvasLock)))
  (define-cstruct* _EvasEventMouseOut
    ((button _sint) ;(output _struct-output) (canvas _struct-canvas)
     (output-x _sint) (output-y _sint)
     (canvas-x _EvasCoord) (canvas-y _EvasCoord)
     (data _scheme) (modifiers _EvasModifier) (locks _EvasLock)))
#|  (define-cstruct _struct-cur-prev
    (;(output _struct-output) (canvas _struct-canvas)))
     (output-x _sint) (output-y _sint)
     (canvas-x _EvasCoord) (canvas-y _EvasCoord)))|#
  (define-cstruct* _EvasEventMouseMove
    ((buttons _sint) ;(cur _struct-cur-prev) (prev _struct-cur-prev)
     (cur-output-x _sint) (cur-output-y _sint)
     (cur-canvas-x _EvasCoord) (cur-canvas-y _EvasCoord)
     (prev-output-x _sint) (prev-output-y _sint)
     (prev-canvas-x _EvasCoord) (prev-canvas-y _EvasCoord)
     (data _scheme) (modifiers _EvasModifier) (locks _EvasLock)))  
  (define-cstruct* _EvasEventMouseWheel
    ((direction _sint) (z _sint) ;(output _struct-output) (canvas _struct-canvas)
     (output-x _sint) (output-y _sint)
     (canvas-x _EvasCoord) (canvas-y _EvasCoord)
     (data _scheme) (modifiers _EvasModifier)
     (locks _EvasLock)))
  (define-cstruct* _EvasEventKeyDown
    ((keyname _string) (data _scheme) (modifiers _EvasModifier)
     (locks _EvasLock) (key _string) (string _string) (compose _string)))
  (define-cstruct* _EvasEventKeyUp
    ((keyname _string) (data _scheme) (modifiers _EvasModifier)
     (locks _EvasLock) (key _string) (string _string) (compose _string)))

  (define init-count 0)
  
  ;; Functions
  (defevas* evas-init :
    (post: (set! init-count o_init-count))
    -> (o_init-count : _sint))
  (defevas* evas-shutdown :
    (post: (set! init-count o_init-count))
    -> (o_init-count : _sint))
  
  (define (evas-finalize e)
    (when (> init-count 0) (evas-free e)))
  (defevas evas-free : _Evas -> _void)
  
  (defevas* evas-new :
    (post: (if o_evas
               (register-finalizer o_evas evas-finalize)
               (evas-raise-exn : "Failed to allocate an Evas.")))
    -> (o_evas : _Evas/null)) ;FIX:crash if this gets GCed before initialized
                              ;force initialization?? or leave it to a higher
                              ;level interface? or just, don't register a finalizer?
  
  (defevas* evas-render-method-lookup : _string -> _sint)
  
  (defevas* evas-render-method-list : -> (_EvasList _string/utf-8/free))
;  (defevas evas-render-method-list-free : _pointer -> _void) ; not used
  (defevas* evas-output-method-set : _Evas _sint -> _void)
  (defevas* evas-output-method-get : _Evas -> _sint)
  (defevas* evas-engine-info-get : _Evas -> _EvasEngineInfo-pointer) ;FIX:autotype
  (defevas* evas-engine-info-set : _Evas _EvasEngineInfo-pointer -> _void)
  
  (defevas* evas-output-size-set : _Evas _sint _sint -> _void)
  (defevas* evas-output-size-get :
    _Evas (o_w : (_ptr o _sint)) (o_h : (_ptr o _sint))
    -> _void
    -> (cons o_w o_h))
  
  (defevas* evas-output-viewport-set :
    _Evas _EvasCoord _EvasCoord _EvasCoord _EvasCoord
    -> _void)
  (defevas* evas-output-viewport-get :
    _Evas
    (o_x : (_ptr o _EvasCoord))
    (o_y : (_ptr o _EvasCoord))
    (o_w : (_ptr o _EvasCoord))
    (o_h : (_ptr o _EvasCoord))
    -> _void
    -> (list o_x o_y o_w o_h))
  
  (defevas* evas-coord-screen-x-to-world : _Evas _sint -> _EvasCoord)
  (defevas* evas-coord-screen-y-to-world : _Evas _sint -> _EvasCoord)
  (defevas* evas-coord-world-x-to-screen : _Evas _sint -> _EvasCoord)
  (defevas* evas-coord-world-y-to-screen : _Evas _sint -> _EvasCoord)
  
  (defevas* evas-pointer-output-xy-get :
    _Evas (o_x : (_ptr o _sint)) (o_y : (_ptr o _sint))
    -> _void
    -> (cons o_x o_y))
  (defevas* evas-pointer-canvas-xy-get :
    _Evas (o_x : (_ptr o _EvasCoord)) (o_y : (_ptr o _EvasCoord))
    -> _void
    -> (cons o_x o_y))
  
  (defevas* evas-pointer-button-down-mask-get : _Evas -> _sint)
  
  (defevas* evas-pointer-inside-get : _Evas -> _EvasBool)
  
  (defevas* evas-damage-rectangle-add :
    _Evas _sint _sint _sint _sint
    -> _void)
  
  (defevas* evas-obscured-rectangle-add :
    _Evas _sint _sint _sint _sint
    -> _void)
  
  (defevas* evas-obscured-clear : _Evas -> _void)
  
  (defevas* evas-render-updates :
    (post: (register-finalizer o_updates evas-render-updates-free))
    _Evas
    -> (o_updates : (_EvasList _EvasRectangle)))
  
  (defevas evas-render-updates-free : _pointer -> _void)
  
  (defevas* evas-render : _Evas -> _void)
  
  (defevas* evas-object-rectangle-add : _Evas -> _EvasObjectRectangle)
  
  (defevas* evas-object-line-add : _Evas -> _EvasObjectLine)
  
  (defevas* evas-object-line-xy-set :
    _EvasObjectLine _EvasCoord _EvasCoord _EvasCoord _EvasCoord
    -> _void)
  
  (defevas* evas-object-line-xy-get :
    _EvasObjectLine
    (o_x1 : (_ptr o _EvasCoord)) (o_y1 : (_ptr o _EvasCoord))
    (o_x2 : (_ptr o _EvasCoord)) (o_y2 : (_ptr o _EvasCoord))
    -> _void
    -> (list o_x1 o_y1 o_x2 o_y2))
  
  (defevas* evas-object-gradient-add : _Evas -> _EvasObjectGradient)
  
  (defevas* evas-object-gradient-color-add :
    _EvasObjectGradient _sint _sint _sint _sint
    -> _void)
  
  (defevas* evas-object-gradient-colors-clear : _EvasObjectGradient -> _void)
  
  (defevas* evas-object-gradient-angle-set :
    _EvasObjectGradient _EvasAngle
    -> _void)
  
  (defevas* evas-object-gradient-angle-get : _EvasObjectGradient -> _EvasAngle)
  
  (defevas* evas-object-polygon-add : _Evas -> _EvasObjectPolygon)
  
  (defevas* evas-object-polygon-point-add :
    _EvasObjectPolygon _EvasCoord _EvasCoord
    -> _void)
  
  (defevas* evas-object-polygon-points-clear : _EvasObjectPolygon -> _void)
  
  (defevas* evas-object-image-add : _Evas -> _EvasObjectImage)
  (defevas* evas-object-image-file-set : _EvasObjectImage _file _path -> _void)
  
  (defevas* evas-object-image-file-get :
    _EvasObjectImage
    (o_file : (_ptr o _file))
    (o_key : (_ptr o _path))
    -> _void
    -> (cons o_file o_key))
  
  (defevas* evas-object-image-border-set :
    _EvasObjectImage _sint _sint _sint _sint -> _void)
  
  (defevas* evas-object-image-border-get :
    _EvasObjectImage
    (o_l : (_ptr o _sint))
    (o_r : (_ptr o _sint))
    (o_t : (_ptr o _sint))
    (o_b : (_ptr o _sint))
    -> _void
    -> (list o_l o_r o_t o_b))
  
  (defevas* evas-object-image-border-center-fill-set :
    _EvasObjectImage _EvasBool
    -> _void)
  
  (defevas* evas-object-image-border-center-fill-get :
    _EvasObjectImage
    -> _EvasBool)
  
  (defevas* evas-object-image-fill-set :
    _EvasObjectImage _EvasCoord _EvasCoord _EvasCoord _EvasCoord -> _void)
  
  (defevas* evas-object-image-fill-get :
    _EvasObjectImage
    (o_x : (_ptr o _EvasCoord))
    (o_y : (_ptr o _EvasCoord))
    (o_w : (_ptr o _EvasCoord))
    (o_h : (_ptr o _EvasCoord))
    -> _void
    -> (list o_x o_y o_w o_h))
  
  (defevas* evas-object-image-size-set : _EvasObjectImage _sint _sint -> _void)
  
  (defevas* evas-object-image-size-get :
    _EvasObjectImage
    (o_w : (_ptr o _sint))
    (o_h : (_ptr o _sint))
    -> _void
    -> (cons o_w o_h))
  
  (defevas* evas-object-image-load-error-get : _EvasObjectImage -> _sint)
  
  (defevas* evas-object-image-data-set : _EvasObjectImage _pointer -> _void) ;FIX
  
  (defevas* evas-object-image-data-get :
    _EvasObjectImage _EvasBool
    -> _pointer) ;FIX
  
  (defevas* evas-object-image-data-copy-set :
    _EvasObjectImage _pointer
    -> _void) ;FIX
  
  (defevas* evas-object-image-data-update-add :
    _EvasObjectImage _sint _sint _sint _sint -> _void)
  
  (defevas* evas-object-image-alpha-set : _EvasObjectImage _EvasBool -> _void)
  (defevas* evas-object-image-alpha-get : _EvasObjectImage -> _EvasBool)
  
  (defevas* evas-object-image-smooth-scale-set :
    _EvasObjectImage _EvasBool
    -> _void)
  
  (defevas* evas-object-image-smooth-scale-get : _EvasObjectImage -> _EvasBool)

  (defevas* evas-object-image-reload : _EvasObjectImage -> _void)
  
  (defevas* evas-object-image-pixels-import :
    _EvasObjectImage _EvasPixelImportSource-pointer
    -> _EvasBool)

  (defevas* evas-object-image-pixels-get-callback-set :
    _EvasObjectImage (_fun _scheme _EvasObjectImage -> _cbvoid) _scheme
    -> _void)
  
  (defevas* evas-object-image-pixels-dirty-set :
    _EvasObjectImage _EvasBool
    -> _void)
  
  (defevas* evas-object-image-pixels-dirty-get : _EvasObjectImage -> _EvasBool)
  
  (defevas* evas-image-cache-flush : _Evas -> _void)
  (defevas* evas-image-cache-reload : _Evas -> _void)
  (defevas* evas-image-cache-set : _Evas _sint -> _void)
  (defevas* evas-image-cache-get : _Evas -> _sint)
  
  (defevas* evas-object-text-add : _Evas -> _EvasObjectText)
  (defevas* evas-object-text-font-source-set : _EvasObjectText _file -> _void)
  (defevas* evas-object-text-font-source-get : _EvasObjectText -> _file)
  
  (defevas* evas-object-text-font-set :
    _EvasObjectText _string _EvasFontSize
    -> _void)
  
  (defevas* evas-object-text-font-get :
    _EvasObjectText
    (o_font : (_ptr o _string))
    (o_size : (_ptr o _EvasFontSize))
    -> _void
    -> (cons o_font o_size))
  
  (defevas* evas-object-text-text-set : _EvasObjectText _string -> _void)
  (defevas* evas-object-text-text-get : _EvasObjectText -> _string)
  (defevas* evas-object-text-ascent-get : _EvasObjectText -> _EvasCoord)
  (defevas* evas-object-text-descent-get : _EvasObjectText -> _EvasCoord)
  (defevas* evas-object-text-max-ascent-get : _EvasObjectText -> _EvasCoord)
  (defevas* evas-object-text-max-descent-get : _EvasObjectText -> _EvasCoord)
  (defevas* evas-object-text-horiz-advance-get : _EvasObjectText -> _EvasCoord)
  (defevas* evas-object-text-vert-advance-get : _EvasObjectText -> _EvasCoord)
  (defevas* evas-object-text-inset-get : _EvasObjectText -> _EvasCoord)
  
  (defevas* evas-object-text-char-pos-get :
    _EvasObjectText _sint
    (o_cx : (_ptr o _EvasCoord))
    (o_cy : (_ptr o _EvasCoord))
    (o_cw : (_ptr o _EvasCoord))
    (o_ch : (_ptr o _EvasCoord))
    -> (o_ret : _sint)
    -> (list o_ret o_cx o_cy o_cw o_ch))
  
  (defevas* evas-object-text-char-coords-get :
    _EvasObjectText _sint _sint
    (o_cx : (_ptr o _EvasCoord))
    (o_cy : (_ptr o _EvasCoord))
    (o_cw : (_ptr o _EvasCoord))
    (o_ch : (_ptr o _EvasCoord))
    -> (o_ret : _sint)
    -> (list o_ret o_cx o_cy o_cw o_ch))
  
  (defevas* evas-string-char-next-get :
    _string _sint (o_decoded : (_ptr o _bool))
    -> (o_ret : _sint)
    -> (cons o_ret o_decoded))
  
  (defevas* evas-string-char-prev-get :
    _string _sint (o_decoded : (_ptr o _bool))
    -> (o_ret : _sint)
    -> (cons o_ret o_decoded))
  
  (defevas* evas-font-path-clear : _Evas -> _void)
  (defevas* evas-font-path-append : _Evas _file -> _void)
  (defevas* evas-font-path-prepend : _Evas _file -> _void)
  (defevas* evas-font-path-list : _Evas -> (_EvasList _file))
  
  (defevas* evas-font-cache-flush : _Evas -> _void)
  (defevas* evas-font-cache-set : _Evas _sint -> _void)
  (defevas* evas-font-cache-get : _Evas -> _sint)
  
  (defevas* evas-object-textblock-add : _Evas -> _EvasObjectTextblock)
  (defevas* evas-object-textblock-clear : _EvasObjectTextblock -> _void)
  
  (defevas* evas-object-textblock-cursor-pos-set :
    _EvasObjectTextblock _sint
    -> _void)
  
  (defevas* evas-object-textblock-cursor-pos-get :
    _EvasObjectTextblock
    -> _sint)
  
  (defevas* evas-object-textblock-length-get :
    _EvasObjectTextblock
    -> _sint)
  
  (defevas* evas-object-textblock-cursor-line-get :
    _EvasObjectTextblock
    -> _sint)
  
  (defevas* evas-object-textblock-lines-get :
    _EvasObjectTextblock
    -> _sint)
  
  (defevas* evas-object-textblock-line-start-pos-get :
    _EvasObjectTextblock
    -> _sint)
  
  (defevas* evas-object-textblock-line-end-pos-get :
    _EvasObjectTextblock
    -> _sint)
  
  (defevas* evas-object-textblock-line-get :
    _EvasObjectTextblock _sint
    (o_lx : (_ptr o _EvasCoord))
    (o_ly : (_ptr o _EvasCoord))
    (o_lw : (_ptr o _EvasCoord))
    (o_lh : (_ptr o _EvasCoord))
    -> (o_success : _EvasBool)
    -> (if o_success
           (list o_lx o_ly o_lw o_lh)
           #f))
  
  (defevas* evas-object-textblock-char-pos-get :
    _EvasObjectTextblock _sint
    (o_cx : (_ptr o _EvasCoord))
    (o_cy : (_ptr o _EvasCoord))
    (o_cw : (_ptr o _EvasCoord))
    (o_ch : (_ptr o _EvasCoord))
    -> (o_success : _EvasBool)
    -> (if o_success
           (list o_cx o_cy o_cw o_ch)
           #f))
  
  (defevas* evas-object-textblock-char-coords-get :
    _EvasObjectTextblock _EvasCoord _EvasCoord
    (o_cx : (_ptr o _EvasCoord))
    (o_cy : (_ptr o _EvasCoord))
    (o_cw : (_ptr o _EvasCoord))
    (o_ch : (_ptr o _EvasCoord))
    -> (o_success : _EvasBool)
    -> (if o_success
           (list o_cx o_cy o_cw o_ch)
           #f))
  (defevas* evas-object-textblock-text-insert :
    _EvasObjectTextblock _string
    -> _void)
  
  (defevas* evas-object-textblock-text-get :
    _EvasObjectTextblock _sint
    -> _string)
  
  (defevas* evas-object-textblock-text-del :
    _EvasObjectTextblock _sint
    -> _void)
  
  (defevas* evas-object-textblock-format-insert :
    _EvasObjectTextblock _string
    -> _void)
  
  (defevas* evas-object-textblock-format-next-pos-get :
    _EvasObjectTextblock
    -> _sint)
  
  (defevas* evas-object-textblock-format-next-count-get :
    _EvasObjectTextblock
    -> _sint)
  
  (defevas* evas-object-textblock-format-next-get :
    _EvasObjectTextblock _sint
    -> _string)
  
  (defevas* evas-object-textblock-format-next-del :
    _EvasObjectTextblock _sint
    -> _void)
  
   (defevas* evas-object-textblock-format-prev-pos-get :
    _EvasObjectTextblock
    -> _sint)
  
  (defevas* evas-object-textblock-format-prev-count-get :
    _EvasObjectTextblock
    -> _sint)
  
  (defevas* evas-object-textblock-format-prev-get :
    _EvasObjectTextblock _sint
    -> _string)
  
  (defevas* evas-object-textblock-format-prev-del :
    _EvasObjectTextblock _sint
    -> _void)

  (defevas* evas-object-textblock-format-current-get :
    _EvasObjectTextblock
    -> _byte)
  
  (defevas* evas-object-textblock-format-size-get :
    _EvasObjectTextblock
    (o_w : (_ptr o _EvasCoord))
    (o_h : (_ptr o _EvasCoord))
    -> _void
    -> (cons o_w o_h))
  
  (defevas* evas-object-textblock-native-size-get :
    _EvasObjectTextblock
    (o_w : (_ptr o _EvasCoord))
    (o_h : (_ptr o _EvasCoord))
    -> _void
    -> (cons o_w o_h))
  
  (defevas* evas-object-textblock-native-lines-get :
    _EvasObjectTextblock
    -> _sint)
  
  (defevas* evas-object-del : _EvasObject -> _void)
  (defevas* evas-object-type-get : _EvasObject -> _string)
  (defevas* evas-object-layer-set : _EvasObject _sint -> _void)
  (defevas* evas-object-layer-get : _EvasObject -> _sint)
  (defevas* evas-object-raise : _EvasObject -> _void)
  (defevas* evas-object-lower : _EvasObject -> _void)
  (defevas* evas-object-stack-above : _EvasObject _EvasObject -> _void)
  (defevas* evas-object-stack-below : _EvasObject _EvasObject -> _void)
  (defevas* evas-object-above-get : _EvasObject -> _EvasObjectAuto)
  (defevas* evas-object-below-get : _EvasObject -> _EvasObjectAuto)
  (defevas* evas-object-bottom-get : _Evas -> _EvasObjectAuto)
  (defevas* evas-object-top-get : _Evas -> _EvasObjectAuto)
  (defevas* evas-object-move : _EvasObject _EvasCoord _EvasCoord -> _void)
  (defevas* evas-object-resize : _EvasObject _EvasCoord _EvasCoord -> _void)
  
  (defevas* evas-object-geometry-get :
    _EvasObject
    (o_x : (_ptr o _EvasCoord))
    (o_y : (_ptr o _EvasCoord))
    (o_w : (_ptr o _EvasCoord))
    (o_h : (_ptr o _EvasCoord))
    -> _void
    -> (list o_x o_y o_w o_h))
  
  (defevas* evas-object-show : _EvasObject -> _void)
  (defevas* evas-object-hide : _EvasObject -> _void)
  (defevas* evas-object-visible-get : _EvasObject -> _EvasBool)
  
  (defevas* evas-object-color-set :
    _EvasObject _sint _sint _sint _sint
    -> _void)
  
  (defevas* evas-object-color-get :
    _EvasObject
    (o_r : (_ptr o _sint))
    (o_g : (_ptr o _sint))
    (o_b : (_ptr o _sint))
    (o_a : (_ptr o _sint))
    -> _void
    -> (list o_r o_g o_b o_a))
  
  (defevas* evas-object-clip-set : _EvasObject _EvasObject -> _void)
  (defevas* evas-object-clip-get : _EvasObject -> _EvasObject)
  (defevas* evas-object-clip-unset : _EvasObject -> _void)
  (defevas* evas-object-clipees-get :
    _EvasObject
    -> (_EvasList _EvasObjectAuto))
  
  (defevas* evas-object-data-set : _EvasObject _string _scheme -> _void)
  (defevas* evas-object-data-get : _EvasObject _string -> _scheme)
  (defevas* evas-object-data-del : _EvasObject _string -> _scheme)
  
  (defevas* evas-object-name-set : _EvasObject _string -> _void)
  (defevas* evas-object-name-get : _EvasObject -> _string)
  (defevas* evas-object-name-find : _Evas _string -> _EvasObjectAuto)
  
  (defevas* evas-object-evas-get : _EvasObject -> _Evas)
  
  (defevas* evas-object-top-at-xy-get :
    _Evas _EvasCoord _EvasCoord _EvasBool _EvasBool
    -> _EvasObject)
  
  (defevas* evas-object-top-at-pointer-get :
    _Evas _EvasCoord _EvasCoord _EvasBool _EvasBool
    -> _EvasObject)
  
  (defevas* evas-object-top-in-rectangle-get :
    _Evas _EvasCoord _EvasCoord _EvasCoord _EvasCoord _EvasBool _EvasBool
    -> _EvasObject)
  
  (defevas* evas-objects-at-xy-get :
    _Evas _EvasCoord _EvasCoord _EvasBool _EvasBool
    -> (_EvasList _EvasObjectAuto))
  
  (defevas* evas-objects-in-rectangle-get :
    _Evas _EvasCoord _EvasCoord _EvasCoord _EvasCoord _EvasBool _EvasBool
    -> (_EvasList _EvasObjectAuto))
  
  (define (evas-smart-finalize es)
    (when (> init-count 0) (evas-smart-free es)))
  (defevas evas-smart-free : _EvasSmart -> _void)
  
  (defevas* evas-smart-new :
    (post: (register-finalizer o_smart evas-smart-finalize))
    _string
    (_fun _EvasObject -> _cbvoid)
    (_fun _EvasObject -> _cbvoid)
    (_fun _EvasObject _sint -> _cbvoid)
    (_fun _EvasObject -> _cbvoid)
    (_fun _EvasObject -> _cbvoid)
    (_fun _EvasObject _EvasObject -> _cbvoid)
    (_fun _EvasObject _EvasObject -> _cbvoid)
    (_fun _EvasObject _EvasCoord _EvasCoord -> _cbvoid)
    (_fun _EvasObject _EvasCoord _EvasCoord -> _cbvoid)
    (_fun _EvasObject -> _cbvoid)
    (_fun _EvasObject -> _cbvoid)
    (_fun _EvasObject _sint _sint _sint _sint -> _cbvoid)
    (_fun _EvasObject _EvasObject -> _cbvoid)
    (_fun _EvasObject -> _cbvoid)
    _scheme
    -> (o_smart : _EvasSmart))
  
  (defevas* evas-smart-class-new : _EvasSmartClass-pointer -> _EvasSmart)
  (defevas* evas-smart-class-get : _EvasSmart -> _EvasSmartClass-pointer)
  (defevas* evas-smart-data-get : _EvasSmart -> _scheme)
  (defevas* evas-object-smart-add : _Evas _EvasSmart -> _EvasObjectSmart)
  
  (defevas* evas-object-smart-member-add :
    _EvasObject _EvasObjectSmart
    -> _void)
  
  (defevas* evas-object-smart-member-del : _EvasObject -> _void)
  (defevas* evas-object-smart-smart-get : _EvasObjectSmart -> _EvasSmart)
  (defevas* evas-object-smart-data-get : _EvasObjectSmart -> _scheme)
  (defevas* evas-object-smart-data-set : _EvasObjectSmart _scheme -> _void)
  
  (defevas* evas-object-smart-callback-add :
    _EvasObjectSmart _string
    (_fun _scheme _EvasObjectSmart _pointer -> _cbvoid)
    _scheme
    -> _void)
  
  (defevas* evas-object-smart-callback-del :
    _EvasObjectSmart _string
    (_fun _scheme _EvasObjectSmart _pointer -> _cbvoid)
    -> _scheme)
  
  (defevas* evas-object-smart-callback-call :
    _EvasObjectSmart _string _pointer
    -> _void)
  
  (defevas* evas-event-freeze : _Evas -> _void)
  (defevas* evas-event-thaw : _Evas -> _void)
  (defevas* evas-event-freeze-get : _Evas -> _sint)
  
  (defevas* evas-event-feed-mouse-down :
    _Evas _sint _EvasButtonFlags _pointer
    -> _void)
  
  (defevas* evas-event-feed-mouse-up :
    _Evas _sint _EvasButtonFlags _pointer
    -> _void)
  
  (defevas* evas-event-feed-mouse-move : _Evas _sint _sint _pointer -> _void)
  (defevas* evas-event-feed-mouse-in : _Evas _pointer -> _void)
  (defevas* evas-event-feed-mouse-out : _Evas _pointer -> _void)
  (defevas* evas-event-feed-mouse-wheel : _Evas _sint _sint _pointer -> _void)
  
  (defevas* evas-event-feed-key-down :
    _Evas _string _string _string _string _pointer
    -> _void)
  
  (defevas* evas-event-feed-key-up :
    _Evas _string _string _string _string _pointer
    -> _void)
  
  (defevas* evas-object-focus-set : _EvasObject _EvasBool -> _void)
  (defevas* evas-object-focus-get : _EvasObject -> _EvasBool)
  (defevas* evas-focus-get : _Evas -> _EvasObject)
  
  (defevas* evas-key-modifier-get : _Evas -> _EvasModifier)
  (defevas* evas-key-lock-get : _Evas -> _EvasLock)
  (defevas* evas-key-modifier-is-set? : _EvasModifier _string -> _EvasBool)
  (defevas* evas-key-lock-is-set? : _EvasLock _string -> _EvasBool)
  (defevas* evas-key-modifier-add : _Evas _string -> _void)
  (defevas* evas-key-modifier-del : _Evas _string -> _void)
  (defevas* evas-key-lock-add : _Evas _string -> _void)
  (defevas* evas-key-lock-del : _Evas _string -> _void)
  (defevas* evas-key-modifier-on : _Evas _string -> _void)
  (defevas* evas-key-modifier-off : _Evas _string -> _void)
  (defevas* evas-key-lock-on : _Evas _string -> _void)
  (defevas* evas-key-lock-off : _Evas _string -> _void)
  (defevas* evas-key-modifier-mask-get : _Evas _string -> _EvasModifierMask)
  
  (defevas* evas-object-key-grab :
    _EvasObject _string _EvasModifierMask _EvasModifierMask _EvasBool
    -> _EvasBool)
  
  (defevas* evas-object-key-ungrab :
    _EvasObject _string _EvasModifierMask _EvasModifierMask
    -> _void)
  
  (defevas* evas-object-pass-events-set : _EvasObject _EvasBool -> _void)
  (defevas* evas-object-pass-events-get : _EvasObject -> _EvasBool)
  (defevas* evas-object-repeat-events-set : _EvasObject _EvasBool -> _void)
  (defevas* evas-object-repeat-events-get : _EvasObject -> _EvasBool)
  
  (define (cb-type->cstruct type)
    (case type
      ((EVAS-CALLBACK-MOUSE-IN) _EvasEventMouseIn-pointer)
      ((EVAS-CALLBACK-MOUSE-OUT) _EvasEventMouseOut-pointer)
      ((EVAS-CALLBACK-MOUSE-DOWN) _EvasEventMouseDown-pointer)
      ((EVAS-CALLBACK-MOUSE-UP) _EvasEventMouseUp-pointer)
      ((EVAS-CALLBACK-MOUSE-MOVE) _EvasEventMouseMove-pointer)
      ((EVAS-CALLBACK-MOUSE-WHEEL) _EvasEventMouseWheel-pointer)
      ((EVAS-CALLBACK-KEY-DOWN) _EvasEventKeyDown-pointer)
      ((EVAS-CALLBACK-KEY-UP) _EvasEventKeyUp-pointer)
      (else _pointer)))
  
  (provide evas-object-event-callback-add)
  (define (evas-object-event-callback-add o ct cb d)
    (let ((type (cb-type->cstruct ct)))
      ((get-ffi-obj "evas_object_event_callback_add" libevas
                   (_fun _EvasObject _EvasCallbackType
                         (_fun _scheme _Evas _EvasObject type -> _cbvoid)
                         _scheme
                         -> _void)) o ct cb d)))

  #|
  (defevas* evas-object-event-callback-add :
    ;tomar argumentos, usar un lambda alrededor del callback, que haga el cast
    _EvasObject _EvasCallbackType
    (_fun _scheme _Evas _EvasObject _pointer -> _cbvoid)
    _scheme
    -> _void)|#
  
  (defevas* evas-object-event-callback-del :
    _EvasObject _EvasCallbackType
    (_fun _scheme _Evas _EvasObject _pointer -> _cbvoid)
    -> _scheme)

  (defevas* evas-object-intercept-show-callback-add :
    _EvasObjectIntercept
    (_fun _scheme _EvasObjectIntercept -> _cbvoid)
    _scheme
    -> _void)
  
  (defevas* evas-object-intercept-show-callback-del :
    _EvasObjectIntercept
    (_fun _scheme _EvasObjectIntercept -> _cbvoid)
    -> _scheme)
  
  (defevas* evas-object-intercept-hide-callback-add :
    _EvasObjectIntercept
    (_fun _scheme _EvasObjectIntercept -> _cbvoid)
    _scheme
    -> _void)
  
  (defevas* evas-object-intercept-hide-callback-del :
    _EvasObjectIntercept
    (_fun _scheme _EvasObjectIntercept -> _cbvoid)
    -> _scheme)
  
  (defevas* evas-object-intercept-move-callback-add :
    _EvasObjectIntercept
    (_fun _scheme _EvasObjectIntercept -> _cbvoid)
    _scheme
    -> _void)
  
  (defevas* evas-object-intercept-move-callback-del :
    _EvasObjectIntercept
    (_fun _scheme _EvasObjectIntercept -> _cbvoid)
    -> _scheme)
  
  (defevas* evas-object-intercept-resize-callback-add :
    _EvasObjectIntercept
    (_fun _scheme _EvasObjectIntercept -> _cbvoid)
    _scheme
    -> _void)
  
  (defevas* evas-object-intercept-resize-callback-del :
    _EvasObjectIntercept
    (_fun _scheme _EvasObjectIntercept -> _cbvoid)
    -> _scheme)
  
  (defevas* evas-object-intercept-raise-callback-add :
    _EvasObjectIntercept
    (_fun _scheme _EvasObjectIntercept -> _cbvoid)
    _scheme
    -> _void)
  
  (defevas* evas-object-intercept-raise-callback-del :
    _EvasObjectIntercept
    (_fun _scheme _EvasObjectIntercept -> _cbvoid)
    -> _scheme)
  
  (defevas* evas-object-intercept-lower-callback-add :
    _EvasObjectIntercept
    (_fun _scheme _EvasObjectIntercept -> _cbvoid)
    _scheme
    -> _void)
  
  (defevas* evas-object-intercept-lower-callback-del :
    _EvasObjectIntercept
    (_fun _scheme _EvasObjectIntercept -> _cbvoid)
    -> _scheme)

  (defevas* evas-object-intercept-stack-above-callback-add :
    _EvasObjectIntercept
    (_fun _scheme _EvasObjectIntercept _EvasObject -> _cbvoid)
    _scheme
    -> _void)
  
  (defevas* evas-object-intercept-stack-above-callback-del :
    _EvasObjectIntercept
    (_fun _scheme _EvasObjectIntercept _EvasObject -> _cbvoid)
    -> _scheme))
